/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package data;

import java.util.*;


public class operations
{


    private static Vector new_fonct(String sym, Vector v, int isrr)
    {	
	
	String newf = "";
	String reste ="";
	int n=0 ;
	try {
	    n = sym.indexOf("(");
	}
	catch (  StringIndexOutOfBoundsException ex)
	    {
		
		n =-1;
	    }
	if ( n != -1 )
	    {
		reste = sym.substring(n,sym.length());
		sym = sym.substring(0,n);
		
	    }

	int e =((Integer)v.elementAt(0)).intValue();

	newf = gui.utils.renvoie_fonct(sym,e,isrr);
	for ( int j=1;j<v.size();j++)
	    {
		e= ((Integer)v.elementAt(j)).intValue();
		
		newf = newf + "|"+gui.utils.renvoie_fonct(sym,e,isrr);
	    }
	Vector retour = new Vector();
	retour.addElement(newf);
	retour.addElement(sym);
	retour.addElement(reste);
	return retour;
	
    }
    // calcule la jointure de 2 automates a1 et a2 sur les champs contenus respectivement dans v1 et v2
    public static automate jointure(automate a1, automate a2, Vector v1, Vector v2) 
    {	

	Vector v3 = new Vector();
	Vector v4 = new Vector();
	
	Integer b = new Integer(1);

	for (int i=0;i<a1.isRR;i++) v3.addElement(new Integer(i+1));	

	for (int i=0;i<a2.isRR;i++) v4.addElement(b);


	
	for ( int j=0;j<v2.size();j++)
	    {	
	
		v4.setElementAt(new Integer(0),((Integer)v2.elementAt(j)).intValue()-1); 
	    }

	Vector v6 = new Vector();

	for ( int j=0;j<v4.size();j++)
	    
	    if (((Integer)v4.elementAt(j)).intValue()!=0) v6.addElement(new Integer(j+1));
	
	alphabet alpha1 = a1.getA_saisie();
	alphabet alpha2 = a2.getA_saisie();
	alphabet alpha3 = new alphabet();
	ensembleTransitions transi1 = a1.getT_saisie();
	ensembleTransitions transi2 = a2.getT_saisie();

	ensembleTransitions transi3= new ensembleTransitions();
	ensembleEtats ensetat3 = new ensembleEtats();


        for ( int i=0;i<transi1.size();i++)
	    {	
		for ( int j=0;j<transi2.size();j++)
		    {
			
			Vector res1 = new_fonct( a1.getT_saisie().getTransition(i).getCondition().getFonction(),v1,a1.isRR);
			Vector res2 = new_fonct( a2.getT_saisie().getTransition(j).getCondition().getFonction(),v2,a2.isRR);
		
		
			if ( res1.elementAt(0).equals(res2.elementAt(0)) )
			    {
			
				// On forme un nouvel tat  l'aide des 2 autres
				String nouv = "";
				nouv = nouv + "{" + transi1.getEtatObtenu(i).getLibelle()+";"+transi2.getEtatObtenu(j).getLibelle()+"}";
				etat newetat = new etat(nouv,transi1.getEtatObtenu(i).isFinal() && transi2.getEtatObtenu(j).isFinal());
				sous_arbres sousarbre1,sousarbre2;
				ensetat3.addEtat(newetat);
			
				if (transi1.getCondition(i).getArbre().getSousArbres().size()==0 && transi2.getCondition(j).getArbre().getSousArbres().size()==0)
				    {
					//on ajoute le symbole de fonction a l'alphabet.
					String sym = new_fonct( a1.getT_saisie().getTransition(i).getCondition().getFonction(),v3,a1.isRR).elementAt(0)+"|"+new_fonct( a2.getT_saisie().getTransition(j).getCondition().getFonction(),v6,a2.isRR).elementAt(0)+"/0";
				symbole sim = new symbole(sym);
					String  s = transi1.getCondition(i).getFonction();
					if ( alpha3.app(s) == -1) alpha3.addSymbole(sim);
					transi3.addTransition(new transition(sim.getSymbole(),newetat));
					
				    }
				else 
				    if (transi1.getCondition(i).getArbre().getSousArbres().size()== transi2.getCondition(j).getArbre().getSousArbres().size())
					{
					  
			
					    sousarbre1 = transi1.getCondition(i).getArbre().getSousArbres().copy();
					    sousarbre2 = transi2.getCondition(j).getArbre().getSousArbres().copy();
					  
					    String sym = new_fonct( a1.getT_saisie().getTransition(i).getCondition().getFonction(),v3,a1.isRR).elementAt(0)+"|"+new_fonct( a2.getT_saisie().getTransition(j).getCondition().getFonction(),v6,a2.isRR).elementAt(0)+"/"+sousarbre1.size();
					    symbole sim = new symbole(sym);
					    String  s = (String)(transi1.getCondition(i).getArbre().getValeur());
					    if ( alpha3.app(s) == -1) alpha3.addSymbole(sim);
					    String condition = sim.getSymbole() + "(";
	
					    for ( int k=0;k<sousarbre1.size();k++)
						{
						 
						    if ( k!=0)  condition += ","; 
						    condition += "{"+sousarbre1.getValeur(k)+";"+sousarbre2.getValeur(k)+"}";
						}
					    condition += ")";
					    transi3.addTransition(new transition(condition,newetat));
					}
			    }
		    }

	    }

;
	int e = a1.isRR*2 - v1.size();


	alphabet alp = a1.getA_saisie().alphabetRR(a1.getARR_saisie(),a1.isRR*2 - v1.size());

	automate retour = new automate (alp,ensetat3,transi3,a1.getARR_saisie());
	
	reduction red = new reduction(retour);
	retour = red.auto_reduit();
	retour.isRR = a1.isRR*2 - v1.size();

       	return retour;

    }


  

    /**
     * Retourne la projection d'une RR sur les champs designs par le vecteur v.
     */

    

    public static automate projection(automate a,Vector v)
    {

	String newf = "";
	ensembleTransitions transi1= new ensembleTransitions();
	alphabet alpha1 = new alphabet();
	alphabet alp = a.getA_saisie().alphabetRR(a.getARR_saisie(),v.size());
	for (int i=0;i<a.getT_saisie().size();i++)
	    {
	
		newf = "";
		String symb = a.getT_saisie().getTransition(i).getCondition().getFonction();
		String reste = "";
	
		Vector result = new_fonct(symb,v,a.isRR);
		
		newf = (String)result.elementAt(0);
		symb = (String)result.elementAt(1);
		reste = (String)result.elementAt(2);
	
		String eta ="";	
	
		if (alp.getSymbole(newf).getArite()!=0)
		    reste = reste.substring(1,reste.length());
		if (alp.getSymbole(newf).getArite()!=0)
		    {
		    for ( int j =1;j<alp.getSymbole(newf).getArite()+1;j++)
		    {
		
			if (j==1) 
			    {
				eta +="(";
				if (j==alp.getSymbole(newf).getArite()) 
				    if ( reste.indexOf(",")!=-1)
					eta +=reste.substring(0,reste.indexOf(","));
				    else
					eta +=reste.substring(0,reste.length()-1);
				else eta +=reste.substring(0,reste.indexOf(","));
				reste = reste.substring(reste.indexOf(",")+1,reste.length());
				
			    }
			else
			    {
				if (j==alp.getSymbole(newf).getArite()) 
				    if ( reste.indexOf(",")!=-1)
					eta +=","+reste.substring(0,reste.indexOf(","));
				    else
					eta +=","+reste.substring(0,reste.length()-1);
				else eta +=","+reste.substring(0,reste.indexOf(","));
				reste = reste.substring(reste.indexOf(",")+1,reste.length());
			    }
			if (j==alp.getSymbole(newf).getArite()) eta +=")";
		
		    }
	    }
		
		if ( !newf.equals("#"))
		    transi1.addTransition( new transition(newf+eta,a.getT_saisie().getTransition(i).getEtatObtenu()));
	
	
		//int in1 = a.getA_saisie().getSymbole(symb).getArite();
		//Integer int1 = new Integer(0);
	
		//String d = int1.toString(in1);
	
		//alpha1.addSymbole(new symbole(newf+"/"+d));
	    } //newf+"/"+a.getA_saisie().getSymbole(symb).getArite()

	automate retour;
	if ( v.size() == 1) 
	    	    {
		if
		( a.getARR_saisie().getSymboleIndex(new String("#"))!=-1);
		    
		  
			a.getARR_saisie().removeElementAt(a.getARR_saisie().getSymboleIndex("#"));
	
		
		retour = new automate(a.getARR_saisie(),a.getE_saisie(),transi1,a.getARR_saisie());
	
	    }
	else
	    retour = new automate(alp,a.getE_saisie(),transi1,a.getARR_saisie());
	retour.isRR = v.size();
	return retour;
    }

    // calcule l'union de 2 automates

    public static automate union(automate a1, automate a2) throws UnionException
    {	

	if(a1.getA_saisie().equals(a2.getA_saisie()))
	    {
		//Q=Q1 U Q2 (contient les tats finaux...)
		ensembleEtats Q = a1.getE_saisie().copy();
		for(int i=0;i<a2.getE_saisie().size();i++)
		    {
			int temp = Q.getEtatIndex(a2.getLibelle(i));
			if(temp==-1)
			    {
				Q.addEtat(a2.getEtat(i));
			    }
			else
			    {
				if(!Q.isFinal(i))
				    Q.getEtat(temp).setFinal(a2.isFinal(i));
			    }
		    }
		//D=D1 U D2
		ensembleTransitions D = a1.getT_saisie().copy();	   
		for(int i=0;i<a2.getT_saisie().size();i++)
		    {
			int temp = D.contient(a2.getTransition(i));
			if(temp==-1)
			    {
				D.addTransition(a2.getTransition(i));}
			else
			    {
				if(!D.getTransition(temp).getEtatObtenu().isFinal())
				    D.getTransition(temp).getEtatObtenu().setFinal(a2.getTransition(i).getEtatObtenu().isFinal());
			    }
		    }
		automate retour = new automate(a2.getA_saisie(),Q,D,a1.getARR_saisie());
		retour.isRR = a1.isRR;
		return retour;
	    }
	else
	    {
		throw new UnionException();
	    }
    }  

    // renvoie true si le langage reconnu par a1 est reconnu par a2, false sinon

    public static boolean inclusion(automate a1, automate a2) throws UnionException
    {
	if(a1.getA_saisie().equals(a2.getA_saisie()))
	    {
	Vector vectorR1 = data.operations.complementaire(a2);

	return test_du_vide(intersection(a1,(automate)vectorR1.elementAt(0)));
	    }
	else
	    {
		throw new UnionException();
	    }
    } 
    
    // renvoie true si a1 inclus dans a2 et inversement, false sinon

    public static boolean equivalence(automate a1, automate a2) throws UnionException
    {
	return inclusion(a1,a2) && inclusion(a2,a1);
        } 

    // renvoie vrai si l'automate a1 definit un langage vide, faux sinon
    
    public static boolean test_du_vide(automate a1) 
    {
	// on reduit pour ameliorer l'efficacite de l'algo
	reduction red = new reduction(a1);
	automate a2= red.auto_reduit();
	// on recupere les etats issus des constantes
	ensembleEtats ens = new ensembleEtats();
	boolean etat_final = false;
	for (int i=0;i<a2.getT_saisie().size();i++)
	    {
	
		String symb = a2.getT_saisie().getTransition(i).getCondition().getFonction();
	
		if ( symb.indexOf("(")== -1 )
		    { 
			if (a2.getA_saisie().getSymbole(symb).getArite() == 0) 
			    {
				ens.addEtat(a2.getT_saisie().getTransition(i).getEtatObtenu());
				if (a2.getT_saisie().getTransition(i).getEtatObtenu().isFinal() ) {
				  
				    etat_final = true;
				}
			    }
		    }
	    }	


	boolean ok = true;	


	while (ok && !etat_final)
	    {
	
		ok = false;
		ensembleEtats ens2 = ens;
	
	
		for (int i=0;i<a2.getT_saisie().size();i++)
		    {
		
			arbre arbre1= a2.getT_saisie().getTransition(i).getCondition().getArbre();
			boolean pas_dedans = false;
		
			if (arbre1.getSousArbres().size() !=0 )
			    {
			
				sous_arbres sousarbre1 = arbre1.getSousArbres();
				for (int j =0;j<sousarbre1.size();j++)
				    {
				
					if ( !ens.contains2(sousarbre1.getValeur(j)) ) pas_dedans = true;
					
				    }
				if ( ! pas_dedans && !ens.contains(a2.getT_saisie().getTransition(i).getEtatObtenu()))
				    {
				
					ens.addEtat(a2.getT_saisie().getTransition(i).getEtatObtenu());
					ok = true;
					if ( a2.getT_saisie().getTransition(i).getEtatObtenu().isFinal() ) etat_final = true;
				    }
				
			    }
		    }
		
	    }


	return !etat_final;
    } 
   

    // renvoie l'automate intersection de a1 et a2

    public static automate intersection(automate a1, automate a2) throws UnionException
    {




	String ok = a2.rename();

        alphabet alpha1 = a1.getA_saisie();
	alphabet alpha2 = a2.getA_saisie();
	alphabet alpha3 = new alphabet();
	ensembleTransitions transi1 = a1.getT_saisie();
	ensembleTransitions transi2 = a2.getT_saisie();

	ensembleTransitions transi3= new ensembleTransitions();
	ensembleEtats ensetat3 = new ensembleEtats();


        for ( int i=0;i<transi1.size();i++)
	    {	
		for ( int j=0;j<transi2.size();j++)
		    {
		
			if (transi1.getCondition(i).getArbre().getValeur().equals(transi2.getCondition(j).getArbre().getValeur()) )
			    {
				// On forme un nouvel tat  l'aide des 2 autres
				String nouv = "";
				nouv = nouv + "{" + transi1.getEtatObtenu(i).getLibelle()+";"+transi2.getEtatObtenu(j).getLibelle()+"}";
				
				etat newetat = new etat(nouv,a1.getE_saisie().getEtat((transi1.getEtatObtenu(i).getLibelle())).isFinal() && a2.getE_saisie().getEtat((transi2.getEtatObtenu(j).getLibelle())).isFinal());	
			
			
				sous_arbres sousarbre1,sousarbre2;
			
				
				ensetat3.addEtat(newetat);
			
				if (transi1.getCondition(i).getArbre().getSousArbres().size()==0 && transi2.getCondition(j).getArbre().getSousArbres().size()==0)
				    {
					//on ajoute le symbole de fonction a l'alphabet.
					symbole sim = new symbole(transi1.getCondition(i).getFonction()+"/0");
					String  s = transi1.getCondition(i).getFonction();
					if ( alpha3.app(s) == -1) alpha3.addSymbole(sim);
					transi3.addTransition(new transition(transi1.getCondition(i),newetat));
					
				    }
				else 
				    if (transi1.getCondition(i).getArbre().getSousArbres().size()== transi2.getCondition(j).getArbre().getSousArbres().size())
					{
					  
					    sousarbre1 = transi1.getCondition(i).getArbre().getSousArbres().copy();
					    sousarbre2 = transi2.getCondition(j).getArbre().getSousArbres().copy();
					  
					    symbole sim = new symbole((String)(transi1.getCondition(i).getArbre().getValeur()+"/"+sousarbre1.size()));
					    String  s = (String)(transi1.getCondition(i).getArbre().getValeur());
					    if ( alpha3.app(s) == -1) alpha3.addSymbole(sim);
					    String condition = transi1.getCondition(i).getArbre().getValeur() + "(";
					    for ( int k=0;k<sousarbre1.size();k++)
						{
						 
						    if ( k!=0)  condition += ","; 
						    condition += "{"+sousarbre1.getValeur(k)+";"+sousarbre2.getValeur(k)+"}";
						}
					    condition += ")";
					    transi3.addTransition(new transition(condition,newetat));
					}
			    }
		
		    }

	    }



	
	automate retour = new automate (a1.getA_saisie(),ensetat3,transi3,a1.getARR_saisie());	

	reduction red = new reduction(retour);
	retour = red.auto_reduit();

	retour.isRR = a1.isRR;

	return retour;

    }


    /**
     * Retourne le complmentaire d'un automate d'arbre (usage interne)
     */
    private static automate complementaire2(automate a){

	ensembleEtats Qc = a.getE_saisie().copy();
	//Qfc = Q - Qf
	//on prend donc les valeurs opposes de final dans Q de a.
	for(int i=0;i<Qc.size();i++){
	    Qc.setFinal(i,!Qc.isFinal(i));}

	// permet de changer l'etat isfinal des etats resultants
	ensembleTransitions Qt = new ensembleTransitions();

	for ( int i=0;i<a.getT_saisie().size();i++)
	    {
		Qt.addTransition(new transition(a.getT_saisie().getTransition(i).getCondition(),new etat(a.getT_saisie().getTransition(i).getEtatObtenu().getLibelle(),!a.getT_saisie().getTransition(i).getEtatObtenu().isFinal())));
	    }
	automate retour = new automate(a.getA_saisie().copy(),Qc,Qt,a.getARR_saisie());
	retour.isRR = a.isRR;
	return retour;
    }
    /**
     * Retourne le complmentaire d'un automate d'arbre aprs complmentation puis dterminisation
     */
    public static Vector complementaire(automate a){
	automate retour = a.copy();
	String modif = new String();

	//boolean deterministe = !retour.getT_saisie().left_equals();
	//if(!deterministe){
	    //On regarde si les tats ne contiennent pas de { ou }.
	    //Si oui, on renomme les tats.
	    //et donc on modif les rgles de transitions.
	    String rename = retour.rename();
	    retour = (new algo_DET(retour)).auto_DET();
	    if(modif.equals("")){
		modif = "determinized";		
	    }
	    else{
		modif+=", determinized";}
	    if(!rename.equals("")){
		modif +=":\n" + "Renamed States:\n" + rename;
	    }
	    //}
	retour = (complementaire2(retour));
	boolean complet=(new completude(retour)).isComplet();
	if(!complet){
	    retour = (new completude(retour)).auto_complet();
	    retour.getE_saisie().getEtat("dead").setFinal(true);
	    modif = "completed";
	}	
	String message = new String(modif);
	Vector Vretour = new Vector();
	Vretour.addElement(retour);
	Vretour.addElement(message);
	return Vretour;
    }
  
}
