/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui;

import java.io.*;
import javax.swing.filechooser.*;


public class automateFileFilter extends javax.swing.filechooser.FileFilter{

   public String getExtension(File f){
       String ext = null;
       String s = f.getName();
       int i = s.lastIndexOf('.');
  
       if (i > 0 &&  i < s.length() - 1){
	   ext = s.substring(i+1).toLowerCase();
       }
       return ext;
   }
  
   // Accept dir and .ta files
    public boolean accept(File f){
	if (f.isDirectory()){
	    return true;
	}
  
	String extension = getExtension(f);
	if (extension != null){
	    if (extension.equals("ta")){
		return true;}
	    else{
		return false;}
	}else{     
	    return false;
	}
    }
    // The description of this filter
    public String getDescription(){
	return "Tree Automata Files (.ta)";
    }
}

