/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui;

import data.*;
import java.util.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import javax.swing.*; 
import javax.swing.event.*; 

/** 
 *Fenetre d'essai 
 */ 
public class fenetre_essai extends JPanel implements ActionListener { 
    JTextField expression; 
    JComboBox choixS; 
    JButton run,by;
    JButton nouveau; 
    JPanel droite;
    JPanel gauche;
    JLabel lgauche;
    run run0;
    int run_visible;
    arbre visible; 
    draw runing0,runing; 
    JTextField jtf; 
    boolean first_display;
    boolean run_ok;
    zoomRun zr;
    JButton first;
    JButton prec;
    JButton suiv;
    JButton last;
    JButton zoom_run;
    JButton pict_expr;
    JToolBar toolbar;
    fenetre_saisie parent;
    public fenetre_essai(fenetre_saisie parent) { 
	this.parent = parent;
	setLayout(null);
	run_ok=false;
	first_display=true;
	JLabel lexpression = new JLabel("Enter a term :"); 
	lexpression.setBounds(20,10,200,25); 
	nouveau = new JButton("Delete",new ImageIcon("images/delete.gif"));
	nouveau.setBounds(20,35,120,25);
	//nouveau.setBackground(Color.gray); 
	//nouveau.addActionListener(this);
	nouveau.setActionCommand("NEW");
	expression = new JTextField(); 
	expression.setBounds(150,35,200,20); 
	expression.setActionCommand("EXPRESSION"); 
        choixS = new JComboBox(); 
	choixS.setBounds(360,35,100,20); 
        choixS.setEditable(false); 
	choixS.setActionCommand("CHOIXS2"); 
	by = new JButton("Ok");	
	by.setToolTipText("Add the symbol selected");
	by.setActionCommand("OK3");
	by.setBounds(395,65,55,20); 
	run = new JButton("Run",new ImageIcon("images/exec.gif")); 
	//run.setBackground(Color.gray); 
	run.setBounds(470,35,90,25);
	//run.addActionListener(this);
	run.setActionCommand("RUN");
	lgauche = new JLabel("Typed term :");
	JLabel ldroite = new JLabel("Run :");
	lgauche.setBounds(20,75,250,20);
	ldroite.setBounds(300,75,250,20);
	gauche = new JPanel();
	gauche.setLayout(new BorderLayout());
	gauche.setBackground(Color.lightGray);
	JScrollPane jspG = new JScrollPane(gauche);
	jspG.setBounds(20,100,260,230);
	//SNAPSHOT
	pict_expr = new JButton("Save", new ImageIcon("images/save.gif"));
	pict_expr.setBounds(70,340,160,25);
	pict_expr.addActionListener(this);
	pict_expr.setActionCommand("Snapshot");
        //JButton first = new JButton("|<"); 
	first = new JButton(new ImageIcon("images/first.gif"));
        first.addActionListener(this); 
	first.setActionCommand("|<");
        //JButton prec = new JButton("<");
	prec = new JButton(new ImageIcon("images/back.gif"));
        prec.addActionListener(this);
	prec.setActionCommand("<");
        //JButton suiv = new JButton(">");
	suiv = new JButton(new ImageIcon("images/forward.gif"));	
        suiv.addActionListener(this);
	suiv.setActionCommand(">");
        //JButton last = new JButton(">|"); 
	last = new JButton(new ImageIcon("images/last.gif"));
        last.addActionListener(this); 
	last.setActionCommand(">|");
	zoom_run = new JButton("Zoom",new ImageIcon("images/zoom.gif"));
	zoom_run.addActionListener(this);
	zoom_run.setActionCommand("zoom_run");
        toolbar = new JToolBar(); 
	toolbar.setFloatable(false);
        toolbar.add(first); 
        toolbar.addSeparator(); 
        toolbar.add(prec);         
        toolbar.add(suiv); 
        toolbar.addSeparator(); 
        toolbar.add(last);
	toolbar.addSeparator();
	toolbar.add(zoom_run);
	toolbar.setBounds(320,335,220,30);
	JLabel lregle = new JLabel("Transitions used:");
	lregle.setBounds(300,285,260,20);
	droite = new JPanel();
	droite.setLayout(new BorderLayout());
	droite.setBackground(Color.lightGray);
	JScrollPane jspD = new JScrollPane(droite);
	jspD.setBounds(305,100,250,180);
	jtf = new JTextField();
	jtf.setEditable(false);
	jtf.setBounds(300,310,260,25);

	add(lexpression); 
	add(nouveau);
	add(expression); 
	add(choixS); 
	add(run); 
	add(lgauche);
	add(ldroite);
	add(lregle);
	add(jspG);
	add(toolbar);
	add(jspD);
	add(jtf);
	add(by);
	add(pict_expr);
    } 
    /** 
     *Vide les listes et les champs de saisies 
     */ 
    public void vide_liste(fenetre_saisie f) { 
	expression.setText("");
	vide_run();
	if (choixS.getModel().getSize()!=0)
	    {
		choixS.removeActionListener(f); 
		choixS.removeAllItems();
		choixS.addActionListener(f); 
	    }
	run_ok=false;
    } 
    /**
     *vide l'affichage du run
     */
    public void vide_run() {
	jtf.setText("");
	if(!first_display) {
	    gauche.remove(runing0);
	    gauche.repaint();
	    droite.remove(runing);
	    droite.repaint();
	}
	first.setEnabled(false);
	prec.setEnabled(false);
	suiv.setEnabled(false);
	last.setEnabled(false);
	zoom_run.setEnabled(false);
    }
    /** 
     *ajuste les parentheses 
     *@param t terme a parentheser 
     */ 
    public String parenthesage(String t,automate a) {
	String retour = new String(t);
	int po=0;
	int pf=0;
	int i=0;
	while(i<retour.length()) {
	    if(retour.charAt(i) == '(') po++;//po >= 1
	    if(retour.charAt(i) == ')') pf++;
	    i++;
	}
	if(retour.indexOf(',') == -1) {
	    while(!retour.endsWith("(") && po != pf && retour.indexOf(',') == -1) {
		int pof = 0;
		int pff = 0;
		String temp = new String();
		int j = retour.length()-1;
		while(pof <= pff) {
		    temp = (retour.charAt(j) + temp);
		    if(retour.charAt(j) == ')') pff++;
		    if(retour.charAt(j) == '(') pof++;
		    j--;
		}
		String temp2 = new String(retour.substring(0,retour.lastIndexOf(temp)));
		if(temp2.indexOf('(') != -1) temp = (temp2.substring(temp2.lastIndexOf('(')+1,temp2.length()) + temp);
		else temp = temp2 + temp;// -1 == -1
		int arite = a.getArite(a.getA_saisie().getSymboleIndex(temp.substring(0,temp.indexOf('('))));
		if(arite == 1) {
		    retour += ")";
		    pf++;
		}
		else retour += ",";
	    }
	}
	else {
	    while(!retour.endsWith("(") && !retour.endsWith(",") && po != pf) {
		int pof = 0;
		int pff = 0;
		String temp = new String();
		int j = retour.length()-1;
		while(pof <= pff) {
		    temp = (retour.charAt(j) + temp);
		    if(retour.charAt(j) == ')') pff++;
		    if(retour.charAt(j) == '(') pof++;
		    j--;
		}
		String temp2 = new String(retour.substring(0,retour.lastIndexOf(temp)));
		if(temp2.lastIndexOf('(') > temp2.lastIndexOf(',')) temp = (temp2.substring(temp2.lastIndexOf('(')+1,temp2.length()) + temp);
		else {
		    if(temp2.lastIndexOf('(') < temp2.lastIndexOf(',')) temp = (temp2.substring(temp2.lastIndexOf(',')+1,temp2.length()) + temp);
		    else temp = temp2 + temp;// -1 == -1
		}
		int arite = a.getArite(a.getA_saisie().getSymboleIndex(temp.substring(0,temp.indexOf('('))));
		temp2 = new String(temp.substring(temp.indexOf('(')+1,temp.length()));
		i = 0;
		int virgule = 0;
		int parenthese = 0;
		while(i<temp2.length()) {
		    if(temp2.charAt(i) == '(') parenthese++;
		    else {
			if(temp2.charAt(i) == ')') parenthese--;
			else {
			    if(temp2.charAt(i) == ',' && parenthese == 0) virgule++;
			}
		    }
		    i++;
		}
		if(arite == virgule + 1) {
		    retour += ")";
		    pf++;
		}
		else retour += ",";
	    }
	}
	return retour;
    }

    public void updateRun(run r) {
	run_ok=r.getOk();

	this.run0 = r;
        run_visible = 0; 
       
	if(r.getResultat())
	    lgauche.setText("Typed term : accepted");
	else
	    lgauche.setText("Typed term : refused");
	//if ( r.getOk())
	    {
		visible = r.getRun(run_visible);
		if(first_display){
		    runing0 = new draw(r.getExpression().getArbre());
		    gauche.add(runing0,BorderLayout.CENTER);	
		    gauche.updateUI();     
		    runing = new draw(visible); 
		    droite.add(runing, BorderLayout.CENTER);
		    droite.updateUI();
		    first_display=false;
		}
		else{	
		   
		    gauche.remove(runing0);
		    gauche.repaint();
		    runing0 = new draw(r.getExpression().getArbre());	  
		    gauche.add(runing0,BorderLayout.CENTER);	
		    gauche.updateUI();
		    droite.remove(runing);
		    droite.repaint();
		    runing = new draw(visible); 
		    droite.add(runing, BorderLayout.CENTER);
		    droite.updateUI();
		    first_display=false; 
		}
		if ( r.getOk() ) jtf.setText(r.getTransition(run_visible).print());
	    }

    }


    public void actionPerformed(ActionEvent e){ 
	boolean modif = false;
	if(run_ok) {
	    if(e.getActionCommand().equals(">")) { 
		if(run_visible==run0.getNombreTransitions()-1) run_visible=0; 
		else run_visible++;             
		visible = run0.getRun(run_visible); 
		jtf.setText(run0.getTransition(run_visible).print()); 
		modif = true;
	    }
	    else{ 
		if(e.getActionCommand().equals("<")) { 
		    if(run_visible>0) run_visible--; 
		    else run_visible=run0.getNombreTransitions()-1; 
		    visible = run0.getRun(run_visible); 
		    jtf.setText(run0.getTransition(run_visible).print()); 
		    modif = true;		
		}
		else { 
		    if(e.getActionCommand().equals("|<")) { 
			run_visible=0; 
			visible = run0.getRun(run_visible); 
			jtf.setText(run0.getTransition(run_visible).print()); 
			modif=true;
		    } 
		    else { 
			if(e.getActionCommand().equals(">|")) { 
			    run_visible=run0.getNombreTransitions()-1; 
			    visible = run0.getRun(run_visible); 
			    jtf.setText(run0.getTransition(run_visible).print()); 
			    modif=true;
			}
			else {
			    if(e.getActionCommand().equals("zoom_run")) 
				zr = new zoomRun(run0);
			    else{
				if(e.getActionCommand().equals("Snapshot")){
				    gui.utilsGraph.enregistrerExpression((JFrame) parent,(JComponent)gauche);
				    boolean save_run = (JOptionPane.showConfirmDialog(parent,"Would you like to save the run etapes ?","Run etapes",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE) == JOptionPane.YES_OPTION);
				    if(save_run){
					String pattern = gui.utilsGraph.enregistrerRun((JFrame) parent);
					//System.out.println(pattern);
					if(!pattern.equals("")){
					    pattern = pattern.substring(0,pattern.length()-4);
					    int actuel = run_visible;
					    toolbar.setEnabled(false);
					    for(int i=0;i<run0.getNombreTransitions();i++){
						run_visible = i;
						visible = run0.getRun(run_visible);
						jtf.setText(run0.getTransition(run_visible).print());
						droite.remove(runing);
						droite.repaint();
						runing = new draw(visible); 
						droite.add(runing, BorderLayout.CENTER);
						droite.updateUI();
						updateUI();
						validate();
						String filename = pattern+ "_" + i + ".jpg";
						//System.out.println(filename);
						gui.utilsGraph.writeJpegFile((JComponent)droite,filename,0);
					    }
					    run_visible = actuel;
					    visible = run0.getRun(run_visible); 
					    jtf.setText(run0.getTransition(run_visible).print()); 
					    modif=true;				    
					}
				    }
				}
			    }
			}
		    }
		}
	    }
	}
	if(modif){
	    droite.remove(runing);
	    droite.repaint();
	    runing = new draw(visible); 
	    droite.add(runing, BorderLayout.CENTER);
	    droite.updateUI();
	    modif = false;
	}
    }//fin actionPerformed
    
} 
