/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui;

import data.*;
import java.util.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import javax.swing.*; 
import javax.swing.event.*; 

public class operations extends JPanel implements ActionListener{

    treeView tree;
    JTextArea desc_automate;
    JTextField parametres;
    JComboBox operations;
    final JPopupMenu jpm_add_treeView;
    JButton add_treeView;
    JLabel choix;
    JButton zoom;
    JButton enregistrer;
    JButton ok;
    JButton select_treeView;
    JButton remplacer;
    automate resultat;
    fenetre_saisie parent;
    int nb_parametres;
    String param1,param2;
    JTextField chaine;
    String saisie;

    public operations(fenetre_saisie parent){
	super();
	setLayout(null);
	this.parent = parent;
	nb_parametres = 0;	
	param1 = new String("");
	param2 = new String("");
	//TreeView
	tree = new treeView(this);
	tree.setBounds(10,10,150,300);
	add(tree);
	//JToolbar du treeView
	JToolBar jtb_treeView = new JToolBar();
	jtb_treeView.setFloatable(false);
	jtb_treeView.setBounds(10,320,165,30);
	add_treeView = new JButton(new ImageIcon("images/add.gif"));
	add_treeView.setToolTipText("Add an automaton");
	JButton del_treeView = new JButton(new ImageIcon("images/delete.gif"));
	del_treeView.addActionListener(this);
	del_treeView.setActionCommand("del_treeView");
	del_treeView.setToolTipText("Delete selected automaton");
	JButton save_treeView = new JButton(new ImageIcon("images/save.gif"));
	save_treeView.addActionListener(this);
	save_treeView.setActionCommand("save_treeView");
	save_treeView.setToolTipText("Save list");
	JButton open_treeView = new JButton(new ImageIcon("images/open.gif"));
	open_treeView.addActionListener(this);
	open_treeView.setActionCommand("open_treeView");
	open_treeView.setToolTipText("Open an automaton list");
	select_treeView = new JButton(new ImageIcon("images/select.gif"));	
	select_treeView.addActionListener(this);
	select_treeView.setActionCommand("select");
	select_treeView.setToolTipText("Add the selected automaton in operation");
	JButton zoom_treeView = new JButton(new ImageIcon("images/zoom.gif"));
	zoom_treeView.addActionListener(this);
	zoom_treeView.setActionCommand("zoom2");
	zoom_treeView.setToolTipText("Information on the selected automaton");
	jtb_treeView.add(open_treeView);
	jtb_treeView.add(save_treeView);
	//jtb_treeView.addSeparator();
	jtb_treeView.add(select_treeView);
	jtb_treeView.add(zoom_treeView);
	jtb_treeView.add(add_treeView);       
	//jtb_treeView.addSeparator();
	jtb_treeView.add(del_treeView);
	add(jtb_treeView);
	//Popupmenu du add
	jpm_add_treeView = new JPopupMenu();
	JMenuItem jpm_add_treeView_file = new JMenuItem("Add an automaton");
	jpm_add_treeView_file.addActionListener(this);
	jpm_add_treeView_file.setActionCommand("jpm_add_treeView_file");
	JMenuItem jpm_add_treeView_dir = new JMenuItem("Add a directory");
	jpm_add_treeView_dir.addActionListener(this);
	jpm_add_treeView_dir.setActionCommand("jpm_add_treeView_dir");
	JMenuItem jpm_add_treeView_dir_rec = new JMenuItem("Add a directory (recursive)");
	jpm_add_treeView_dir_rec.addActionListener(this);
	jpm_add_treeView_dir_rec.setActionCommand("jpm_add_treeView_dir_rec");
	JMenuItem jpm_add_treeView_create_dir = new JMenuItem("Create a directory ");
	jpm_add_treeView_create_dir.addActionListener(this);
	jpm_add_treeView_create_dir.setActionCommand("jpm_add_treeView_create_dir");
	jpm_add_treeView.add(jpm_add_treeView_file);
	jpm_add_treeView.add(jpm_add_treeView_dir);
	jpm_add_treeView.add(jpm_add_treeView_dir_rec);
	jpm_add_treeView.add(jpm_add_treeView_create_dir);	
	add_treeView.addMouseListener(new MouseAdapter(){
		public void mousePressed(MouseEvent evt){
		    jpm_add_treeView.show(evt.getComponent(),evt.getX(),evt.getY());
		}
		public void mouseReleased(MouseEvent evt){
		    jpm_add_treeView.show(evt.getComponent(),evt.getX(),evt.getY());
		}
	    });
	
		
	//Combo opration
	operations = new JComboBox();	
	operations.addItem("Union");
	operations.addItem("Intersection");
	operations.addItem("Complement");
	operations.addItem("Emptyness");
	operations.addItem("Inclusion");
	operations.addItem("Equivalence");
       	operations.addItem("Projection");
	operations.addItem("Join");
	operations.addItem("Renaming");
	operations.setSelectedIndex(0);

	//Jlabel du choix
	choix = new JLabel("Choose 2 automata.");	
	choix.setBounds(170,10,250,20);
	add(choix);
	setChoix();
	operations.addActionListener(this);
	operations.setActionCommand("operations");
	operations.setBounds(170,30,160,20);
	add(operations);
	
	//TextFiled paramtres
	parametres = new JTextField();
	parametres.setEditable(false);
	parametres.setBackground(Color.lightGray); 
	parametres.setBounds(340,30,200,20);
	add(parametres);

	//Boutons pour JTextField
	JButton effacer = new JButton("Delete",new ImageIcon("images/delete.gif"));
	ok = new JButton("Operation", new ImageIcon("images/exec.gif"));
	effacer.setBounds(360,60,160,25);
	ok.setBounds(170,60,160,25);
	ok.setEnabled(false);
	effacer.addActionListener(this);
	effacer.setActionCommand("effacer");	
	ok.addActionListener(this);
	ok.setActionCommand("ok_operation");
	add(effacer);
	add(ok);

	//Zone de texte et son tiquette
	JLabel resultat = new JLabel("Result:");
	resultat.setBounds(170,100,200,20);
	add(resultat);
	desc_automate = new JTextArea("");
	desc_automate.setCaretPosition(0);
	desc_automate.setEditable(false);	
	desc_automate.setLineWrap(true); 
	desc_automate.setBackground(Color.lightGray); 
	desc_automate.setMargin(new Insets(5,5,5,5));
	JScrollPane jsp = new JScrollPane(desc_automate);
	jsp.setBounds(170,120,370,190);
	add(jsp);

	//TextFiled paramtres	
	JLabel sais = new JLabel("projection/join components");
	sais.setBounds(320,80,200,20);
	add(sais);
	chaine = new JTextField();
	chaine.setEditable(true);
	chaine.setBackground(Color.lightGray); 
	chaine.setBounds(400,100,100,20);
	chaine.addActionListener(this);
	chaine.setActionCommand("PROJ");

	//Boutons zoom et enregistrer
	remplacer = new JButton(new ImageIcon("images/modify.gif"));
	remplacer.setBounds(520,320,25,25);
	remplacer.setToolTipText("Replace current automaton");
	zoom = new JButton("See All", new ImageIcon("images/zoom.gif"));
	enregistrer = new JButton("Save",new ImageIcon("images/save.gif"));
	zoom.setBounds(185,320,150,25);
	enregistrer.setBounds(365,320,150,25);
	zoom.setEnabled(false);
	enregistrer.setEnabled(false);
	remplacer.setEnabled(false);
	zoom.addActionListener(this);
	zoom.setActionCommand("zoom");
	remplacer.addActionListener(this);
	remplacer.setActionCommand("remplacer");
	enregistrer.addActionListener(this);
	enregistrer.setActionCommand("save");
	add(zoom);
	add(enregistrer);
	add(remplacer);
	add(chaine);
    }

    public void setChoix(){       
	if(operations.getSelectedItem().toString().equals("Complement") || operations.getSelectedItem().toString().equals("Emptyness") || operations.getSelectedItem().toString().equals("Projection") || operations.getSelectedItem().toString().equals("Renaming")){
	    choix.setText("Choose 1 automaton.");
	}else{
	    choix.setText("Choose 2 automata.");
	}
			
    }

    public void actionPerformed(ActionEvent e){	
	if(e.getActionCommand().equals("PROJ")){
	    setChoix();
	    parametres.setText("");
	    nb_parametres=0;
	    ok.setEnabled(false);
	    param1="";
	    param2="";
	    saisie = chaine.getText();
	    
	    //remove(chaine);
	}else
	//Modif de l'tiquette "choisissez n automate(s)
	if(e.getActionCommand().equals("operations")){
	    setChoix();
	    parametres.setText("");
	    nb_parametres=0;
	    ok.setEnabled(false);
	    param1="";
	    param2="";
	}else{
	    //Remise  zro des champs.
	    if(e.getActionCommand().equals("effacer")){
		desc_automate.setText("");
		parametres.setText("");
		zoom.setEnabled(false);
		enregistrer.setEnabled(false);
		remplacer.setEnabled(false);
		ok.setEnabled(false);
		nb_parametres = 0;
		desc_automate.setText("");
		enregistrer.setEnabled(false);
		zoom.setEnabled(false);
		operations.setEnabled(true);
		select_treeView.setEnabled(true);
		resultat = new automate();
	    }else{
		//Sauvegarde du rsultat
		if(e.getActionCommand().equals("save")){
		   
		    gui.utils.enregistrer(resultat,parent);
		}else{		    
		    //Ajout d'un automate
		    if(e.getActionCommand().equals("jpm_add_treeView_file")){
			String fichier = gui.utils.choisirFichier(parent);
			if(!fichier.equals(""))
			    tree.addAutomate(fichier);
		    }else{
			//Ajout d'un repertoire (sans recursion)
			if(e.getActionCommand().equals("jpm_add_treeView_dir")){
			    String dir = gui.utils.choisirDir(parent);
			    if(!dir.equals(""))
				tree.addDirAutomate(dir,false);
			}else{
			    //Ajout d'un rpertoire (recursif)
			    if(e.getActionCommand().equals("jpm_add_treeView_dir_rec")){
				String dir = gui.utils.choisirDir(parent);
				if(!dir.equals(""))
				    tree.addDirAutomate(dir,true);
			    }else{
				//Suppression d'un fichier ou rpertoire
				if(e.getActionCommand().equals("del_treeView")){
				    tree.delSelection();
				}else{
				    //Cration d'un rpertoire
				    if(e.getActionCommand().equals("jpm_add_treeView_create_dir")){
					String dirName = JOptionPane.showInputDialog(this,"Name of new directory?","Create a new directory.",JOptionPane.QUESTION_MESSAGE);
					if(dirName!=null){
					    tree.createDir(dirName);
					}
				    }else{
					//Sauvegarde de la liste.
					if(e.getActionCommand().equals("save_treeView")){
					    gui.utils.enregistrerTreeNode(parent,tree.tree.getModel());
					}else{
					    //Ouverture de la liste
					    if(e.getActionCommand().equals("open_treeView")){					 
						tree.tree.setModel(gui.utils.ouvrirTreeNode(parent, tree.tree));
						tree.tree.updateUI();
					    }else{
						if(e.getActionCommand().equals("select")){						    						    //Complmentaire
						    if(( operations.getSelectedItem().toString().equals("Complement") || operations.getSelectedItem().toString().equals("Renaming") ) && parametres.getText().equals("")){					       
							String[] temp = tree.getSelected();
							if(!temp[0].equals("")){
							    param1 = temp[1];
							    parametres.setText("("+temp[0]+")");
							    nb_parametres = 1;
							    ok.setEnabled(true);}
						    }
						    else if ( operations.getSelectedItem().toString().equals("Emptyness"))
							{
							    String[] temp = tree.getSelected();
							    if(!temp[0].equals("")){
							    param1 = temp[1];
							    parametres.setText("("+temp[0]+")");
							    nb_parametres = 1;
							    ok.setEnabled(true);}
							} 
						    else if ( operations.getSelectedItem().toString().equals("Projection"))
							{
							    String[] temp = tree.getSelected();
							    if(!temp[0].equals("")){
							    param1 = temp[1];
							    parametres.setText("("+temp[0]+")");
							    nb_parametres = 1;
							    ok.setEnabled(true);}
							}
else{
							String[] temp = tree.getSelected();
							if(nb_parametres==0){						
							    if(!temp[0].equals("")){
								nb_parametres = 1;
								param1 = temp[1];
								parametres.setText("("+temp[0]+",");
							    }
							}
							else{
							    if(nb_parametres==1){
								if(!temp[0].equals("")){
								    nb_parametres = 2;
								    param2 = temp[1];
								    parametres.setText(parametres.getText()+temp[0]+")");  
								    ok.setEnabled(true);
								}
							    }
							}
						    }    						    
						}else{
						    if(e.getActionCommand().equals("ok_operation")){
							desc_automate.setText("");
							automate a1 = new automate(new File(param1));
						
							if(operations.getSelectedItem().toString().equals("Complement"))
							    {
						       
								Vector vectorR = data.operations.complementaire(a1);
								resultat = (automate)vectorR.elementAt(0);
								String message = (String)vectorR.elementAt(1);;
								if(message.equals(""))
								    desc_automate.setText(resultat.print());
								else
								    desc_automate.setText("Achieved modifications:\n"+ message + "\n\n" + resultat.print());
								enregistrer.setEnabled(true);
								zoom.setEnabled(true);
								remplacer.setEnabled(true);
								operations.setEnabled(false);
								select_treeView.setEnabled(false);
							    }
							else if(operations.getSelectedItem().toString().equals("Emptyness"))
							    {
								boolean result = data.operations.test_du_vide(a1);
								if ( result ) JOptionPane.showMessageDialog(this, "The language recognized by the automaton is empty" , "Result", 0); else JOptionPane.showMessageDialog(this, "The language recognized by the automaton is not empty" , "Result", 0);
							    }
							else if(operations.getSelectedItem().toString().equals("Projection"))
							    {
							
								Vector v = gui.utils.renvoie_proj(saisie,a1.isRR);
								int ok = ((Integer)v.elementAt(0)).intValue();
							
								Vector v1 = (Vector)v.elementAt(1);
								resultat = data.operations.projection(a1,v1);
							
								desc_automate.setText(resultat.print()); 
								desc_automate.setCaretPosition(0);
								enregistrer.setEnabled(true);
								zoom.setEnabled(true);
								remplacer.setEnabled(true);
								operations.setEnabled(false);
								select_treeView.setEnabled(false);
								validate();
								chaine.setText("");
							    }
							else {
							    automate a2 = new automate(new File(param2));
							    if(operations.getSelectedItem().toString().equals("Union")){
								try{
								    a2 = utils.renomme(a1,a2);
								   
								    resultat = data.operations.union(a1,a2);
								    desc_automate.setText("");
								    validate();
								    desc_automate.setText(resultat.print());
								    desc_automate.setCaretPosition(0);
								    enregistrer.setEnabled(true);
								    zoom.setEnabled(true);
								    remplacer.setEnabled(true);
								    operations.setEnabled(false);
								    select_treeView.setEnabled(false);
								    validate();
								}catch(UnionException ex){
								    JOptionPane.showMessageDialog(this,  "Non valid automata:\n" +ex.getMessage(), "Error message", 0);
								}
							    }else
								if (operations.getSelectedItem().toString().equals("Equivalence")) {
								    try {
									boolean result = data.operations.equivalence(a1,a2);
									if ( result ) JOptionPane.showMessageDialog(this, "The automaton  " +param1+" and the automaton " + param2 +" are equivalent"); else JOptionPane.showMessageDialog(this, "The automaton " +param2+" and the automaton " + param2 +" are not equivalent");
								    }
								    catch(UnionException ex){
									JOptionPane.showMessageDialog(this, "Non valid automata:\n" +ex.getMessage(), "Error message", 0);
								    }
								}
								else if (operations.getSelectedItem().toString().equals("Inclusion")) { try {
									boolean result = data.operations.inclusion(a1,a2);
									if ( result ) JOptionPane.showMessageDialog(this, "The langage recognized by " +param1+" is recognized by " + param2 ); else JOptionPane.showMessageDialog(this, "The langage recognized by " +param1+" is not recognized by " + param2 );
								    }
								    catch(UnionException ex){
									JOptionPane.showMessageDialog(this, "Non valid automata:\n" +ex.getMessage(), "Error message", 0);
								    }
								}
							    else if (operations.getSelectedItem().toString().equals("Join")) { 
								
							
								Vector v1 = gui.utils.renvoie_join(saisie,a1.isRR,1);
								Vector v2 = gui.utils.renvoie_join(saisie,a1.isRR,2);
							
								resultat =data.operations.jointure(a1,a2,v1,v2); 
								desc_automate.setText("");
								    validate();
								    //    if(message.equals(""))
									desc_automate.setText(resultat.print());
									//  else
									// desc_automate.setText("MODIFICATIONS effectues:\n"+ message + "\n\n" + resultat.print());
								    desc_automate.setCaretPosition(0);
								    enregistrer.setEnabled(true);
								    zoom.setEnabled(true);
								    remplacer.setEnabled(true);
								    operations.setEnabled(false);
								    select_treeView.setEnabled(false);
								    validate();
								    chaine.setText("");
							

							    }
								else if (operations.getSelectedItem().toString().equals("Renaming")) { 
								
								    
								   
								   
								   
								   
								    resultat = a1;
								    resultat = utils.renomme_tous(resultat,parent);
								    desc_automate.setText("");
								    validate();
								    //    if(message.equals(""))
									desc_automate.setText(resultat.print());
									//  else
									// desc_automate.setText("MODIFICATIONS effectues:\n"+ message + "\n\n" + resultat.print());
								    desc_automate.setCaretPosition(0);
								    enregistrer.setEnabled(true);
								    zoom.setEnabled(true);
								    remplacer.setEnabled(true);
								    operations.setEnabled(false);
								    select_treeView.setEnabled(false);
								    validate();
							    
							

							    }
								else {
								try{

								    resultat =data.operations.intersection(a1,a2);
								    desc_automate.setText("");
								    validate();
								    //    if(message.equals(""))
									desc_automate.setText(resultat.print());
									//  else
									// desc_automate.setText("MODIFICATIONS effectues:\n"+ message + "\n\n" + resultat.print());
								    desc_automate.setCaretPosition(0);
								    enregistrer.setEnabled(true);
								    zoom.setEnabled(true);
								    remplacer.setEnabled(true);
								    operations.setEnabled(false);
								    select_treeView.setEnabled(false);
								    validate();
								}catch(UnionException ex){
								    JOptionPane.showMessageDialog(this, "Non valid automata:\n" +ex.getMessage(), "Error message", 0);
								}
							    }
							ok.setEnabled(false);
							parametres.setText("");
							nb_parametres =0;}}
						    else{
							if(e.getActionCommand().equals("zoom")){
							    String titre = operations.getSelectedItem().toString()+"(automaton 1";
							    String texte = new String("Automaton 1:\n\n" + (new automate(new File(param1))).print()+"\n\n");
							    if(operations.getSelectedItem().toString().equals("Complement")){
								titre = titre + ")";
								texte = texte + "Result:\n\n" + desc_automate.getText();
							    }else{
								titre = titre + ",automaton 2)";
								texte = texte + "Automaton 2:\n\n" + (new automate(new File(param2))).print()+"\n\n";
								texte = texte + "Result:\n\n" + desc_automate.getText();
							    }
							    zoomOperation zo = new zoomOperation(titre,texte);
							}else{
							    if(e.getActionCommand().equals("zoom2")){
								tree.zoom();
							    }else{
								if(e.getActionCommand().equals("remplacer")){
								    if(JOptionPane.showConfirmDialog(parent,"Do you want this automaton to be the current automaton ?","Use of the new automaton",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE) == JOptionPane.YES_OPTION) {
									parent.new_automate(); 
									gui.utils.save(resultat,parent.user_dir+"/.auto.ta.temp");
																	automate data = new automate(new File(parent.user_dir+"/.auto.ta.temp"));									
									parent.data = data;		    
									for(int i = 0; i < data.getA_saisie().size(); i++) { 
									    ((DefaultListModel)parent.sse.symbol_saisie.getModel()).addElement(new String(data.getSymbole(i) + "/" + data.getArite(i)));
									    String fonction = parent.data.getA_saisie().getSymbole(i).convertSymbolFonction(); 
									    parent.sr.choixS.removeActionListener(parent); 
									    parent.sr.choixS.addItem(fonction); 
									    parent.sr.choixS.addActionListener(parent); 
									    parent.fe.choixS.removeActionListener(parent); 
									    parent.fe.choixS.addItem(fonction); 
									    parent.fe.choixS.addActionListener(parent); 
									} 
									for(int j = 0; j < data.getE_saisie().size(); j++) { 
									    
									    if(data.isFinal(j))		      
										((DefaultListModel)parent.sse.etat_saisie.getModel()).addElement(new String(data.getLibelle(j) + " (final)"));
									    else  
										((DefaultListModel)parent.sse.etat_saisie.getModel()).addElement(data.getLibelle(j));
									    
									    parent.sr.choixE.removeActionListener(parent); 
									    parent.sr.choixE.addItem(data.getLibelle(j)); 
									    parent.sr.choixE.addActionListener(parent); 
									} 
									for(int k = 0; k < data.getT_saisie().size(); k++){ 		    
									    ((DefaultListModel)parent.sr.regle_saisie.getModel()).addElement(data.getCondition(k).getFonction() + "->" + data.getEtatObtenu(k).getLibelle()); 
									}		    
									parent.data.setAutomate_ok(true); 
									parent.activation_onglet();
									parent.tab.setSelectedIndex(4);
								    }
								}
							    }
							} 	
						    } 
						}
					    }
					}
				    }
				}
			    }
			}
		    }
		}
	    }
	}
    }
}
