/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui;

import data.*;
import java.util.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import javax.swing.*; 
import javax.swing.event.*; 
import javax.swing.border.*;

/** 
 *Fenetre de saisie des regles de transitions 
 */ 
public class saisie_regle extends JPanel   {
    /** 
     *Liste des symboles pour la saisie d'une regle 
     */ 
    JComboBox choixS; 
    /** 
     *Liste des etats pour la saisie d'une regle 
     */ 
    JComboBox choixE; 
    /** 
     *Champs de saisie d'une regle 
     */ 
    JTextField regle; 
    /**
     *bouton new pour le champs de saisie regle
     */
    JButton nouveau;
    /** 
     *Liste des regles saisies 
     */ 
    JList regle_saisie; 
    /** 
     *ScrollBarre de regle_saisie 
     */ 
    JScrollPane jsp_regle_saisie; 
    /** 
     *Bouton undo la derniere regle 
     */ 
    JButton undoR; 
    /** 
     *Bouton de validation d'une regle 
     */ 
    JButton jbv; 
    /** 
     *Bouton de validation de l'automate 
     */ 
    JButton jbva,by,be; 
    /** 
     *Constructeur 
     fenetre_saisie parent
     */
    fenetre_saisie parent;
    public saisie_regle() {
	setLayout(null); 
	this.parent = parent;
	JLabel lregle = new JLabel("Enter a transition :"); 
	lregle.setBounds(20,20,280,20); 
	regle = new JTextField(); 
	regle.setBounds(20,50,280,20); 
	regle.setActionCommand("REGLE"); 
	//regle.addActionListener(this);

        choixS = new JComboBox(); 
	choixS.setBounds(310,50,120,20); 
        choixS.setEditable(false); 
	choixS.setActionCommand("CHOIXS"); 
	//choixS.addActionListener(this);

	by = new JButton("Ok");
	by.setToolTipText("Add the symbol selected");
	by.setActionCommand("OK1");
	by.setBounds(345,75,55,20); 

        choixE = new JComboBox(); 
	choixE.setBounds(440,50,120,20); 
        choixE.setEditable(false); 
	choixE.setActionCommand("CHOIXE"); 
	choixE.setVisible(false);
	//choixE.addActionListener(parent.this);

	be = new JButton("Ok");	
	be.setToolTipText("Add the state selected");
	be.setActionCommand("OK2");
	be.setBounds(475,75,55,20); 
	be.setVisible(false);

	nouveau = new JButton("New", new ImageIcon("images/new.gif"));
	nouveau.setActionCommand("NEW");
	nouveau.setBounds(130,100,140,30);
	//nouveau.setBackground(Color.gray);
	//nouveau.addActionListener(this);

	jbv = new JButton("Add", new ImageIcon("images/add.gif"));
	jbv.setActionCommand("ajoutez");
	jbv.setBounds(290,100,140,30); 
	//jbv.setBackground(Color.gray); 
	//jbv.addActionListener(this);
 
	JLabel lregle_saisie = new JLabel("List of transitions :"); 
	lregle_saisie.setBounds(20,140,250,20); 
	regle_saisie = new JList(); 
	regle_saisie.setSelectionMode(DefaultListSelectionModel.MULTIPLE_INTERVAL_SELECTION);	
	regle_saisie.setModel(new DefaultListModel());
	//regle_saisie.setEditable(false); 
	jsp_regle_saisie = new JScrollPane(regle_saisie); 
	jsp_regle_saisie.setBounds(20,170,300,150); 
	jsp_regle_saisie.getViewport().add(regle_saisie);  
 
	undoR = new JButton("Delete", new ImageIcon("images/delete.gif")); 
	undoR.setActionCommand("UndoRegle");
	//undoR.setBackground(Color.gray); 
	undoR.setBounds(100,330,140,30); 
	//undoR.addActionListener(this);

	JLabel lva= new JLabel("Valid automaton ?"); 
	lva.setBounds(350,180,180,20); 
	jbva = new JButton("OK"); 
	jbva.setBounds(400,210,60,30); 
	//jbva.setBackground(Color.gray); 
	//jbva.addActionListener(this);

	add(jsp_regle_saisie); 
	add(lregle_saisie); 
	add(lregle); 
	add(regle); 
	add(jbv); 
	add(nouveau);
	add(choixE); 
	add(choixS); 
	add(undoR); 
	add(by);
	add(be);
	add(lva); 
	add(jbva); 
    } 
   
    /** 
     *Vide les listes et les champs de saisies 
     */ 
    public void vide_liste(fenetre_saisie f) { 
	
	regle.setText(""); 
	
       	gui.utils.emptyList(regle_saisie); 

	if (choixS.getModel().getSize()!=0) 
	    {
		choixS.removeActionListener(f); choixS.removeAllItems(); 	choixS.addActionListener(f);
	    }
	if (choixE.getModel().getSize()!=0)
	    {
		choixE.removeActionListener(f);  choixE.removeAllItems();choixE.addActionListener(f); 
	    }

	
	
	
    } 
    
}
