/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package data;

public class completude{
    /**
    * automate de dpart.
    */
    private automate depart;
    /**
    * automate complt.
    */
    private automate complete;
    /**
    * Indique si l'automate de dpart est complet.
    */
    private boolean complet;
    /**
    * Etat puit.
    */
    private etat  puit; 
    private boolean toutes;
    /**
    * Constructeur
    */
    public completude(automate auto){
	String libelle_puit = new String("dead");
	boolean ok = false;
	int i=0;
	while(!ok){	    
	    if(i>0)
		libelle_puit ="dead_"+i;
	    ok = true;
	    for(int j=0;j<auto.getE_saisie().size();j++){
		if(auto.getEtat(j).getLibelle().lastIndexOf(libelle_puit)!=-1){
		    ok=false;
		    break;
		}
	    }
	    i++;
	}	
	puit = new etat(libelle_puit,false);
	depart = auto;
	complete = depart.copy();
	complete.addEtat(puit);	
	complet = complet(complete);

	//if(!isComplet())
	//  completer(complete);	
    }

    /**
    * Indique si l'automate de dpart est complet;
    */
    public boolean isComplet(){
	return complet;
    }
    private boolean complet(automate a)
    {
		boolean existe = true;
	for (int i=0;i<a.getA_saisie().size() && existe ;i++)
	    {
		int arite = a.getA_saisie().getArite(i);
		int nb_etats = a.getE_saisie().size()-1;
		int v[] = new int[arite];
		if ( arite == 0 )
		    {
					existe =false;
			for (int j=0;j<a.getT_saisie().size() && !existe;j++)
			    {
				if (  a.getT_saisie().getCondition(j).getFonction().equals(a.getA_saisie().getSymbole(i).getSymbole()))
				    {
				
					existe = true;
				    }
			    }
					    }
		else
		    {
						    
			for (int n =1;n<arite+1;n++)
			    {
				v[n-1]=1;
			    }	
		
			boolean ok2=true;
			while (ok2 && existe)
			    {
									
				String chaine="";
				chaine +="(";
				for ( int n=1;n<arite+1;n++)
				    {
					
					if (n!=1) chaine += ","+a.getE_saisie().getEtat(v[n-1]-1).getLibelle();
					else chaine += a.getE_saisie().getEtat(v[n-1]-1).getLibelle();
				    }
				chaine+=")";
				chaine = a.getA_saisie().getSymbole(i).getSymbole()+chaine;
				existe = false;
				for (int j=0;j<a.getT_saisie().size() && !existe;j++)
				    {
									if (  a.getT_saisie().getCondition(j).getFonction().equals(chaine))
					    {	
										existe =true;
					    }
				    }
								
							ok2 = false;
				for (int n=1;n<arite+1;n++)
				    {
					if (v[n-1]!=nb_etats) ok2 =true;
							    }
							v = addv(v,arite-1,nb_etats);
						
			    }	
			
		    }
	    }
	return existe;
	
    }
    
    private int [] addv(int [] v,int n,int max) 
    {

	if (n==-1) return v;
	else	
	if (v[n]<max) {v[n]++; return v;}
	else  { v[n]=1; return addv(v,n-1,max);}
	
    }
    private ensembleTransitions complet2(automate a)
    {
	boolean sortie = false;
	ensembleTransitions temp = new ensembleTransitions();
	for (int i=0;i<a.getA_saisie().size() && sortie ==false;i++)
	    {	
		int arite = a.getA_saisie().getArite(i);
		int nb_etats = a.getE_saisie().size()-1;
		int v[] = new int[arite];
		String chaine ="";
		if (arite !=0)
		    {			for (int n =1;n<arite+1;n++)
			    {
							v[n-1]=1;
						    }
			// on verifie que les indices de boucles sont au maximum du nombre d'etats
			boolean ok = false;	
					for (int n=1;n<arite+1;n++)
			    {
				if (v[n-1]!=nb_etats) ok =true;
			    }
		
			int cpt = 0;
			while ( ok && !sortie)
			    {
		
				cpt++;
				chaine="";
				chaine +="(";
				for ( int n=1;n<arite+1;n++)
				    {
					
					if (n!=1) chaine += ","+a.getE_saisie().getEtat(v[n-1]-1).getLibelle();
					else chaine += a.getE_saisie().getEtat(v[n-1]-1).getLibelle();
				    }
				chaine+=")";
				ok = false;
				for (int n=1;n<arite+1;n++)
				    {
					if (v[n-1]!=nb_etats) ok =true;
				    }
				int num = arite;
				while ( num !=0)
				    {
					if (v[num-1]<nb_etats) { v[num-1]++; num=0;}
					
					else 
					    if (v[num-1] == nb_etats) {;v[num-1]=1;num--;}
					
					
			
					temp.addTransition(new transition(a.getSymbole(i)+chaine,puit));
					for (int k =0;k<a.getT_saisie().size() && sortie ==false;k++)
				    {
					if ( a.getT_saisie().getCondition(k).equals((new transition(a.getSymbole(i)+chaine,puit)).getCondition()))
					    {
						sortie = true;
					
					    }
				    }
				//if(temp.getTransition(i).left_equals(a.getT_saisie().getTransition(j))){
			    }
		    }
		
		temp.addTransition(new transition(a.getSymbole(i)+chaine,puit));
		
	    }
	    }
	toutes = sortie;
	return temp;
    }    
    /** 
    * Verifie si l'automate de dpart est complet. 
    */ 
    private boolean complet3(automate a){
	boolean retour = true; 
	int arite_max = 0; 
for(int i=0;i<a.getA_saisie().size();i++){ 
	    if(depart.getArite(i)>arite_max) 
		arite_max = a.getArite(i); 
	} 
	int nombre_combinaisons_max = 0; 
	for(int i=1;i<=arite_max;i++){ 
	    nombre_combinaisons_max+=(int)java.lang.Math.pow((double)a.getE_saisie().size(),(double)i); 
	} 
	int nombre_combinaisons = 0; 
	int nombre_combinaisons_sans_0 =0;	 
	for(int i=0;i<a.getA_saisie().size();i++){
	   	    if(a.getArite(i)>0){ 
		nombre_combinaisons_sans_0 += (int)java.lang.Math.pow((double)a.getE_saisie().size(),(double)a.getArite(i)); 
		nombre_combinaisons += (int)java.lang.Math.pow((double)a.getE_saisie().size(),(double)a.getArite(i)); 
	    } 
	    else{ 
		nombre_combinaisons++; 
	    } 
	} 	  
	String[] n_uplets = n_uplets(nombre_combinaisons_max,a);

	ensembleTransitions temp = complet2(a);
	
	return toutes; 
    }
    /**
    * Comparaison
    */
    private boolean comparaison(ensembleTransitions temp, automate a, boolean modif){
	boolean retour = true;
	boolean ok[] = new boolean[temp.size()];
	//init de OK
	for(int i=0;i<temp.size();i++)
	    ok[i]=false;

	for(int i=0;i<temp.size();i++){
	    for(int j=0;j<a.getT_saisie().size();j++){
		if(temp.getTransition(i).left_equals(a.getT_saisie().getTransition(j))){
		    ok[i]=true;
		    break;
		}
	    }
	}
	//retour true si tous les OK true.
	for(int i=0;i<temp.size();i++){
	    retour = retour && ok[i];
	    if(!ok[i] && modif)//Ajout de la rgle manquante.
		a.getT_saisie().addTransition(temp.getTransition(i));
	}	
	return retour;
    }
    /**
    * Gnre un enesmble de transitions contenant toutes les parties gauches possibles.
    */
    private ensembleTransitions transitions_possibles(String[] n_uplets, automate a){
	//TOUTES LES PARTIES GAUCHES POSSIBLES:	    
	    ensembleTransitions temp = new ensembleTransitions();	    
	    //Gneration des fonctions.
	    int as =0;
	    for(int i=0;i<a.getA_saisie().size();i++){
		as++;

		int index_min=0;
		int index_max=0;
		if(a.getArite(i)==0){		    temp.addTransition(new transition(a.getSymbole(i),puit));
		}else{		    if(a.getArite(i)==1){			index_min=0;
			index_max=a.getE_saisie().size()-1;
		    }else{			index_min=(int)java.lang.Math.pow((double)a.getE_saisie().size(),(double)a.getArite(i)-1);
			index_max=index_min-1+(int)java.lang.Math.pow((double)a.getE_saisie().size(),(double)a.getArite(i));
		    }
		    		    for(int j=index_min;j<=index_max;j++){		    
			temp.addTransition(new transition(a.getSymbole(i)+"("+n_uplets[j]+")",puit));}
		   		}		
	    }
	    return temp;

    }

    /**
    * Gnre tous les n_uplets possibles.
    */
    private String[] n_uplets(int nombre_combinaisons_max,automate a){
	String n_uplets[] = new String[nombre_combinaisons_max];  

	for(int j=0;j<nombre_combinaisons_max;j++) 
	n_uplets[j]=new String(); 
	    int index=0; 
	    int etat=0; 
	    int before=0; 
         
	    while(index<nombre_combinaisons_max){ 
		if(index<a.getE_saisie().size()){		     
		    n_uplets[index]=a.getLibelle(etat); 
		    index++; 
		    etat++; 
		    before=-1; 
		}else{ 
		    String prefixe = n_uplets[before]; 
		    for(int j=0;j<a.getE_saisie().size();j++){ 
			n_uplets[index]=prefixe+","+a.getLibelle(etat);			     
			    etat++; 
			    index++; 
		    } 
		} 
		if(etat==a.getE_saisie().size()){ 
		    etat=0; 
		    before++;		     
		} 
	    } 	
	return n_uplets;
    }
    /**
    * Indique si toutes les parties gauches possibles sont prsentes
    */
    private boolean all_left(ensembleTransitions possibles, automate a){
	boolean retour = true;
	boolean[] ok= new boolean[possibles.size()];//indique pour chaque possibilt si elle  t trouv.
	for(int i=0;i<possibles.size();i++)
	    ok[i]=false;

	for(int i=0;i<possibles.size();i++){
	    for(int j=0;j<a.getT_saisie().size();j++){
		if(a.getTransition(j).left_equals(possibles.getTransition(i))){
		    ok[i]=true;
		    break;
		}
	    }
	}

	for(int i=0;i<possibles.size();i++)
	    retour = retour && ok[i];
	return retour;
    }
    /**
    * Gnration de l'automate complet.
    */
    private void completer(automate a){
	int arite_max = 0; 
	for(int i=0;i<a.getA_saisie().size();i++){ 
	    if(depart.getArite(i)>arite_max) 
		arite_max = a.getArite(i); 
	} 
	int nombre_combinaisons_max = 0; 
	for(int i=1;i<=arite_max;i++){ 
	    nombre_combinaisons_max+=(int)java.lang.Math.pow((double)a.getE_saisie().size(),(double)i); 
	} 
	int nombre_combinaisons = 0; 
	int nombre_combinaisons_sans_0 =0;	 
	for(int i=0;i<a.getA_saisie().size();i++){	     
	    if(a.getArite(i)>0){ 
		nombre_combinaisons_sans_0 += (int)java.lang.Math.pow((double)a.getE_saisie().size(),(double)a.getArite(i)); 
		nombre_combinaisons += (int)java.lang.Math.pow((double)a.getE_saisie().size(),(double)a.getArite(i)); 
	    } 
	    else{ 
		nombre_combinaisons++; 
	    } 
	} 	  
	String[] n_uplets = n_uplets(nombre_combinaisons_max,a); 
	//TOUTES LES PARTIES GAUCHES POSSIBLES:
	ensembleTransitions temp = transitions_possibles(n_uplets,a);
	//Ajout des rgles manquantes.
	comparaison(temp,a, true);
   }
    /**
    * Retourne l'automate complet.
    */
    public automate auto_complet(){
	completer(complete);
	automate auto_complete=complete;
	if(isComplet())
	    auto_complete = depart;
	return auto_complete;
    }
    /**
    * Retourne l'automate de dpart.
    */
    public automate depart(){
	return depart;
    }
}
