/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package data;

/*   
 *Reprsente un symbole   
 */   
public class symbole {  
    /**  
     * Libell du symbole.  
     */  
    private String symbole;  
    /**  
     * Arit du symbole.  
     */  
    private int arite;   
    /** 
     *Cre un nouveau symbole  partir d'un chaine de type "f/2".   
     *@param symbole Chaine de caractere de type nom/arit.   
     */   
    public symbole(String sym) { 
        int i = 0; 
        String tempSym = new String(); 
        String tempAr = new String(); 
        while(sym.charAt(i) != '/') {  
            tempSym += sym.charAt(i++); 
	} 
	i++; 
        while(i < sym.length()) { 
            tempAr += sym.charAt(i++); 
	} 
        symbole = tempSym; 
        arite = (new Integer(tempAr)).intValue(); 
    }  
    /**  
     *Retourne le symbole.   
     */   
    public String getSymbole() {   
	
	return symbole;   
    }
    /**
    * Retourne symbole/arit
    */
    public String getLibelle(){
	return getSymbole()+"/"+getArite();
    }
    /**  
     *Retourne l'arit.   
     */   
    public int getArite() { 

	return arite;   
    }   
    /**   
    * Indique si 2 symboles sont gaux.   
    * @param other Le symbole  comparer.   
    */   
    public boolean isEqual(String other){   

	return symbole.equals(other);   
    }
    /**   
    * Indique si 2 symboles sont gaux.   
    * @param other Le symbole  comparer.   
    */
    public boolean equals(symbole other){
	return getLibelle().equals(other.getLibelle());
    }
    /** 
     *Retourne le symbole nom/arite sous forme nom( , , ) (si arite=3 ici) 
     */ 
    public String convertSymbolFonction() { 
	String retour = new String(getSymbole()); 
	if(getArite() != 0) { 
	    retour += "( "; 
	    for(int j=1;j<getArite();j++) { 
		retour += ", "; 
	    } 
	    retour += ")"; 
	} 
	return retour; 
    } 
    /**
    * Retourne une copie du symbole.
    */
    public symbole copy(){
	return (new symbole(getSymbole()+"/"+getArite()));
    }
}
