/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui;

import data.*;
import java.util.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import javax.swing.*; 
import javax.swing.event.*; 
 
public class draw extends JComponent{ 
    arbre a;
    int old_height;
    int old_width;    
    int width; 
    int height; 
    Font font; 
    FontMetrics fontMetrics; 
    int default_w = 260;
    int default_h = 230;
    public draw(arbre a){ 
	    super(); 
	    this.a = a; 
	    old_height=0;
	    old_width=0;
	    font = new Font("Times", Font.PLAIN,14); 
	    fontMetrics = getFontMetrics(font);	 
	    width=20+a.largeur(fontMetrics)+20; 
	    height=a.hauteur(fontMetrics);
	    setSize(width,height); 
	    setPreferredSize(new Dimension(width,height));
	    setDoubleBuffered(true); 
	    //this.validate(); 
    } 

    public void paint(Graphics g){ 
	    g.setFont(font);
	    Graphics2D g2d = (Graphics2D)g;	    	     
	    g2d.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
	    int temp_w = width;
	    int temp_x = 20;
	    if(default_w > width){
		temp_w = default_w;
		temp_x = (default_w - width)/2;
	    }
	    int temp_h = height;
	    int temp_y = 20;
	    if(default_h > height){
		temp_h = default_h;
		temp_y = (default_h - height)/2;
	    }
	    g.setColor(Color.white);
	    g.fillRect(0,0,temp_w,temp_h);
	    g.setColor(Color.black);
	    a.draw(g,fontMetrics,temp_x,temp_y);
	    this.validate(); 
    } 
     
    public void update(arbre a){
        this.a = a;
	this.old_width=width;
	this.old_height=height;
	this.width=20+a.largeur(fontMetrics)+20; 
	this.height=a.hauteur(fontMetrics);
	setSize(width,height); 
	setPreferredSize(new Dimension(width,height));        
	repaint();
	//this.validate();
    } 
 
} 
