/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui;

import java.awt.*; 
import java.awt.event.*; 
import javax.swing.*; 
import javax.swing.event.*; 
import java.net.URL;
import java.net.MalformedURLException;
import java.io.*;
import javax.swing.text.*;

public class fenetre_help extends JFrame {
 
    public fenetre_help() {
	//super("Help", true, true, true, true);
	//setFrameIcon((Icon)UIManager.get("Tree.openIcon"));
	//setBounds( 200, 25, 400, 400);
	super("TAJA Documentation");
	setSize(600,400);
	HtmlPane html = new HtmlPane();
	setContentPane(html);
	setVisible(true);
    }
}


class HtmlPane extends JScrollPane implements HyperlinkListener {
    JEditorPane html;

    public HtmlPane() {
	try {
	    File f = new File ("doc/doc.html");
	    String s = f.getAbsolutePath();
	    s = "file:"+s;
	    URL url = new URL(s);
	    html = new JEditorPane(s);
	    html.setEditable(false);
	    html.addHyperlinkListener(this);

	    JViewport vp = getViewport();
	    vp.add(html);
	} 
	catch (MalformedURLException e) {
	    System.out.println("Malformed URL: " + e);
	} 
	catch (IOException e) {
	    System.out.println("IOException: " + e);
	}
    }

    public void hyperlinkUpdate(HyperlinkEvent e) {
	if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
	    linkActivated(e.getURL());
	}
    }

    protected void linkActivated(URL u) {
	Cursor c = html.getCursor();
	Cursor waitCursor = Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR);
	html.setCursor(waitCursor);
	SwingUtilities.invokeLater(new PageLoader(u, c));
    }

class PageLoader implements Runnable {
    URL url;
    Cursor cursor;

    PageLoader(URL u, Cursor c) {
	url = u;
	cursor = c;
    }

    public void run() {
	if (url == null) {
	    html.setCursor(cursor);
	    Container parent = html.getParent();
	    parent.repaint();
	}
	else {
	    Document doc = html.getDocument();
	    try {
		html.setPage(url);
	    } 
	    catch (IOException ioe) {
		html.setDocument(doc);
		getToolkit().beep();
	    } 
	    finally {
		url = null;
		SwingUtilities.invokeLater(this);
	    }
	}
    }
}

}


