/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui;

import data.*;
import java.util.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import javax.swing.*; 
import javax.swing.event.*; 

public class operationsRR extends JPanel implements ActionListener{

    treeView tree;
    JTextArea desc_automate;
    JTextField parametres;
    JComboBox operations;
    final JPopupMenu jpm_add_treeView;
    JButton add_treeView;
    JLabel choix;
    JButton zoom;
    JButton enregistrer;
    JButton ok;
    JButton select_treeView;
    JButton remplacer;
    automate resultat;
    fenetre_saisie parent;
    int nb_parametres;
    String param1,param2;
	
    public operationsRR(fenetre_saisie parent){
	super();
	setLayout(null);
	this.parent = parent;
	nb_parametres = 0;	
	param1 = new String("");
	param2 = new String("");
	//TreeView
	tree = new treeView(this);
	tree.setBounds(10,10,150,300);
	add(tree);
	//JToolbar du treeView
	JToolBar jtb_treeView = new JToolBar();
	jtb_treeView.setFloatable(false);
	jtb_treeView.setBounds(10,320,165,30);
	add_treeView = new JButton(new ImageIcon("images/add.gif"));
	add_treeView.setToolTipText("Ajout d'automate(s)");
	JButton del_treeView = new JButton(new ImageIcon("images/delete.gif"));
	del_treeView.addActionListener(this);
	del_treeView.setActionCommand("del_treeView");
	del_treeView.setToolTipText("Suppression de la slection");
	JButton save_treeView = new JButton(new ImageIcon("images/save.gif"));
	save_treeView.addActionListener(this);
	save_treeView.setActionCommand("save_treeView");
	save_treeView.setToolTipText("Sauvegarde de la liste");
	JButton open_treeView = new JButton(new ImageIcon("images/open.gif"));
	open_treeView.addActionListener(this);
	open_treeView.setActionCommand("open_treeView");
	open_treeView.setToolTipText("Ouverture d'une liste d'automates");
	select_treeView = new JButton(new ImageIcon("images/select.gif"));	
	select_treeView.addActionListener(this);
	select_treeView.setActionCommand("select");
	select_treeView.setToolTipText("Ajout de l'automate slectionn dans l'opration");
	JButton zoom_treeView = new JButton(new ImageIcon("images/zoom.gif"));
	zoom_treeView.addActionListener(this);
	zoom_treeView.setActionCommand("zoom2");
	zoom_treeView.setToolTipText("Information sur l'automate slectionn");
	jtb_treeView.add(open_treeView);
	jtb_treeView.add(save_treeView);
	//jtb_treeView.addSeparator();
	jtb_treeView.add(select_treeView);
	jtb_treeView.add(zoom_treeView);
	jtb_treeView.add(add_treeView);       
	//jtb_treeView.addSeparator();
	jtb_treeView.add(del_treeView);
	add(jtb_treeView);
	//Popupmenu du add
	jpm_add_treeView = new JPopupMenu();
	JMenuItem jpm_add_treeView_file = new JMenuItem("Ajout d'un automate");
	jpm_add_treeView_file.addActionListener(this);
	jpm_add_treeView_file.setActionCommand("jpm_add_treeView_file");
	JMenuItem jpm_add_treeView_dir = new JMenuItem("Ajout d'un rpertoire");
	jpm_add_treeView_dir.addActionListener(this);
	jpm_add_treeView_dir.setActionCommand("jpm_add_treeView_dir");
	JMenuItem jpm_add_treeView_dir_rec = new JMenuItem("Ajout d'un rpertoire (recursif)");
	jpm_add_treeView_dir_rec.addActionListener(this);
	jpm_add_treeView_dir_rec.setActionCommand("jpm_add_treeView_dir_rec");
	JMenuItem jpm_add_treeView_create_dir = new JMenuItem("Cration d'un repertoire");
	jpm_add_treeView_create_dir.addActionListener(this);
	jpm_add_treeView_create_dir.setActionCommand("jpm_add_treeView_create_dir");
	jpm_add_treeView.add(jpm_add_treeView_file);
	jpm_add_treeView.add(jpm_add_treeView_dir);
	jpm_add_treeView.add(jpm_add_treeView_dir_rec);
	jpm_add_treeView.add(jpm_add_treeView_create_dir);	
	add_treeView.addMouseListener(new MouseAdapter(){
		public void mousePressed(MouseEvent evt){
		    jpm_add_treeView.show(evt.getComponent(),evt.getX(),evt.getY());
		}
		public void mouseReleased(MouseEvent evt){
		    jpm_add_treeView.show(evt.getComponent(),evt.getX(),evt.getY());
		}
	    });
	
		
	//Combo opration
	operations = new JComboBox();	
	operations.addItem("Projection");

	operations.setSelectedIndex(0);

	//Jlabel du choix
	choix = new JLabel("Choisissez 1 automate.");	
	choix.setBounds(170,10,250,20);
	add(choix);
	setChoixRR();
	operations.addActionListener(this);
	operations.setActionCommand("operations");
	operations.setBounds(170,30,160,20);
	add(operations);
	
	//TextFiled paramtres
	parametres = new JTextField();
	parametres.setEditable(false);
	parametres.setBackground(Color.lightGray); 
	parametres.setBounds(340,30,200,20);
	add(parametres);

	//Boutons pour JTextField
	JButton effacer = new JButton("Effacer",new ImageIcon("images/delete.gif"));
	ok = new JButton("Opration", new ImageIcon("images/exec.gif"));
	effacer.setBounds(360,60,160,25);
	ok.setBounds(170,60,160,25);
	ok.setEnabled(false);
	effacer.addActionListener(this);
	effacer.setActionCommand("effacer");	
	ok.addActionListener(this);
	ok.setActionCommand("ok_operation");
	add(effacer);
	add(ok);

	//Zone de texte et son tiquette
	JLabel resultat = new JLabel("Rsultat:");
	resultat.setBounds(170,100,200,20);
	add(resultat);
	desc_automate = new JTextArea("");
	desc_automate.setCaretPosition(0);
	desc_automate.setEditable(false);	
	desc_automate.setLineWrap(true); 
	desc_automate.setBackground(Color.lightGray); 
	desc_automate.setMargin(new Insets(5,5,5,5));
	JScrollPane jsp = new JScrollPane(desc_automate);
	jsp.setBounds(170,120,370,190);
	add(jsp);

	//Boutons zoom et enregistrer
	remplacer = new JButton(new ImageIcon("images/modify.gif"));
	remplacer.setBounds(520,320,25,25);
	remplacer.setToolTipText("Remplace l'automate courant");
	zoom = new JButton("Tout voir", new ImageIcon("images/zoom.gif"));
	enregistrer = new JButton("Enregistrer",new ImageIcon("images/save.gif"));
	zoom.setBounds(185,320,150,25);
	enregistrer.setBounds(365,320,150,25);
	zoom.setEnabled(false);
	enregistrer.setEnabled(false);
	remplacer.setEnabled(false);
	zoom.addActionListener(this);
	zoom.setActionCommand("zoom");
	remplacer.addActionListener(this);
	remplacer.setActionCommand("remplacer");
	enregistrer.addActionListener(this);
	enregistrer.setActionCommand("save");
	add(zoom);
	add(enregistrer);
	add(remplacer);
    }

    public void setChoixRR(){       
	if(operations.getSelectedItem().toString().equals("Projection")){
	    choix.setText("Choisissez 1 automate.");
	}else{
	    choix.setText("Choisissez 2 automates.");
	}
    }

    public void actionPerformed(ActionEvent e){
	//Modif de l'tiquette "choisissez n automate(s)
	if(e.getActionCommand().equals("operations")){
	    setChoixRR();
	    parametres.setText("");
	    nb_parametres=0;
	    ok.setEnabled(false);
	    param1="";
	    param2="";
	}else{
	    //Remise  zro des champs.
	    if(e.getActionCommand().equals("effacer")){
		desc_automate.setText("");
		parametres.setText("");
		zoom.setEnabled(false);
		enregistrer.setEnabled(false);
		remplacer.setEnabled(false);
		ok.setEnabled(false);
		nb_parametres = 0;
		desc_automate.setText("");
		enregistrer.setEnabled(false);
		zoom.setEnabled(false);
		operations.setEnabled(true);
		select_treeView.setEnabled(true);
	    }else{
		//Sauvegarde du rsultat
		if(e.getActionCommand().equals("save")){
		    gui.utils.enregistrer(resultat,parent);
		}else{		    
		    //Ajout d'un automate
		    if(e.getActionCommand().equals("jpm_add_treeView_file")){
			String fichier = gui.utils.choisirFichier(parent);
			if(!fichier.equals(""))
			    tree.addAutomate(fichier);
		    }else{
			//Ajout d'un repertoire (sans recursion)
			if(e.getActionCommand().equals("jpm_add_treeView_dir")){
			    String dir = gui.utils.choisirDir(parent);
			    if(!dir.equals(""))
				tree.addDirAutomate(dir,false);
			}else{
			    //Ajout d'un rpertoire (recursif)
			    if(e.getActionCommand().equals("jpm_add_treeView_dir_rec")){
				String dir = gui.utils.choisirDir(parent);
				if(!dir.equals(""))
				    tree.addDirAutomate(dir,true);
			    }else{
				//Suppression d'un fichier ou rpertoire
				if(e.getActionCommand().equals("del_treeView")){
				    tree.delSelection();
				}else{
				    //Cration d'un rpertoire
				    if(e.getActionCommand().equals("jpm_add_treeView_create_dir")){
					String dirName = JOptionPane.showInputDialog(this,"Nom du nouveau rpertoire?","Cration d'un nouveau rpertoire.",JOptionPane.QUESTION_MESSAGE);
					if(dirName!=null){
					    tree.createDir(dirName);
					}
				    }else{
					//Sauvegarde de la liste.
					if(e.getActionCommand().equals("save_treeView")){
					    gui.utils.enregistrerTreeNode(parent,tree.tree.getModel());
					}else{
					    //Ouverture de la liste
					    if(e.getActionCommand().equals("open_treeView")){					 
						tree.tree.setModel(gui.utils.ouvrirTreeNode(parent, tree.tree));
						tree.tree.updateUI();
					    }else{
						if(e.getActionCommand().equals("select")){						    						    //Complmentaire
						    if(operations.getSelectedItem().toString().equals("Complmentaire")
						       && parametres.getText().equals("")){					       
							String[] temp = tree.getSelected();
							if(!temp[0].equals("")){
							    param1 = temp[1];
							    parametres.setText("("+temp[0]+")");
							    nb_parametres = 1;
							    ok.setEnabled(true);}
						    }else{
							String[] temp = tree.getSelected();
							if(nb_parametres==0){						
							    if(!temp[0].equals("")){
								nb_parametres = 1;
								param1 = temp[1];
								parametres.setText("("+temp[0]+",");
							    }
							}
							else{
							    if(nb_parametres==1){
								if(!temp[0].equals("")){
								    nb_parametres = 2;
								    param2 = temp[1];
								    parametres.setText(parametres.getText()+temp[0]+")");  
								    ok.setEnabled(true);
								}
							    }
							}
						    }    						    
						}else{
						    if(e.getActionCommand().equals("ok_operation")){
							desc_automate.setText("");
							automate a1 = new automate(new File(param1));
							if(operations.getSelectedItem().toString().equals("Projection")){
							    // faire la projection
							  }
							else{
							    automate a2 = new automate(new File(param2));
							  
							ok.setEnabled(false);
							parametres.setText("");
							nb_parametres =0;}}
						    else{
							if(e.getActionCommand().equals("zoom")){
							    String titre = operations.getSelectedItem().toString()+"(automate 1";
							    String texte = new String("Automate 1:\n\n" + (new automate(new File(param1))).print()+"\n\n");
							    if(operations.getSelectedItem().toString().equals("Complmentaire")){
								titre = titre + ")";
								texte = texte + "Rsultat:\n\n" + desc_automate.getText();
							    }else{
								titre = titre + ",automate 2)";
								texte = texte + "Automate 2:\n\n" + (new automate(new File(param2))).print()+"\n\n";
								texte = texte + "Rsultat:\n\n" + desc_automate.getText();
							    }
							    zoomOperation zo = new zoomOperation(titre,texte);
							}else{
							    if(e.getActionCommand().equals("zoom2")){
								tree.zoom();
							    }else{
								if(e.getActionCommand().equals("remplacer")){
								    //System.out.println("replace");
								    if(JOptionPane.showConfirmDialog(parent,"voulez vous que cet automate devienne l'automate courant ?","Utilisation du nouvel automate",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE) == JOptionPane.YES_OPTION) {
									parent.new_automate(); 
									gui.utils.save(resultat,parent.user_dir+"/.auto.ta.temp");
									automate data = new automate(new File(parent.user_dir+"/.auto.ta.temp"));									
									parent.data = data;		    
									for(int i = 0; i < data.getA_saisie().size(); i++) { 
									    ((DefaultListModel)parent.sse.symbol_saisie.getModel()).addElement(new String(data.getSymbole(i) + "/" + data.getArite(i)));
									    String fonction = parent.data.getA_saisie().getSymbole(i).convertSymbolFonction(); 
									    parent.sr.choixS.removeActionListener(parent); 
									    parent.sr.choixS.addItem(fonction); 
									    parent.sr.choixS.addActionListener(parent); 
									    parent.fe.choixS.removeActionListener(parent); 
									    parent.fe.choixS.addItem(fonction); 
									    parent.fe.choixS.addActionListener(parent); 
									} 
									for(int j = 0; j < data.getE_saisie().size(); j++) { 
									    
									    if(data.isFinal(j))		      
										((DefaultListModel)parent.sse.etat_saisie.getModel()).addElement(new String(data.getLibelle(j) + " (final)"));
									    else  
										((DefaultListModel)parent.sse.etat_saisie.getModel()).addElement(data.getLibelle(j));
									    
									    parent.sr.choixE.removeActionListener(parent); 
									    parent.sr.choixE.addItem(data.getLibelle(j)); 
									    parent.sr.choixE.addActionListener(parent); 
									} 
									for(int k = 0; k < data.getT_saisie().size(); k++){ 		    
									    ((DefaultListModel)parent.sr.regle_saisie.getModel()).addElement(data.getCondition(k).getFonction() + "->" + data.getEtatObtenu(k).getLibelle()); 
									}		    
									parent.data.setAutomate_ok(true); 
									parent.activation_onglet();
									parent.tab.setSelectedIndex(4);
								    }
								}
							    }
							} 	
						    } 
						}
					    }
					}
				    }
				}
			    }
			}
		    }
		}
	    }
	}
    }
}
