/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui;

import data.*;
import java.util.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import javax.swing.*; 
import javax.swing.event.*;
import javax.swing.border.*;

/* 
 *Fenetre de saisie des symboles et des etats 
 */ 
public class saisie_symbole_etat extends JPanel implements ActionListener{ 

    /** 
     *Champs de saisie d'un symbole de l'alphabet 
     */ 
    JTextField symbol; 
    /** 
     *Champs de saisie d'un etat 
     */ 
    JTextField etat; 
    /** 
     *Champs de saisie d'un etat de larit pour une RR
     */ 
    JTextField arite; 
    /** 
     *etat final ou non 
     */ 
    JCheckBox isfinal; 
    /**
     *Relation rgulire ou non 
     */ 
    JCheckBox isrr;
    /** 
     *Zone d'affichage des symboles saisies 
     */ 
    JList symbol_saisie; 
    /** 
     *Zone d'affichage des etats selectionnes 
     */ 
    JList etat_saisie; 
    /** 
     *Bouton Undo 
     */ 
    JButton undoS,undoE; 
    /**
    * JFrame parent
    */
    fenetre_saisie parent;
    /**    /**
    * Etats
    */
    JPanel etats;
    /**
    * Symboles
    */
    JPanel symboles;
    JLabel ariteRR;
 
    /* 
     *Constructeur de la fenetre de saisie 
     */ 
    public saisie_symbole_etat(fenetre_saisie parent) { 


	setLayout(null); 
	this.parent = parent;

	//SYMBOLES 20,20,260,450

	ariteRR = new JLabel ("Length of tree-tuples");
	ariteRR.setBounds(20,10,200,20);
	arite = new JTextField(); 
	arite.setBounds(230,10,20,20);
	arite.addActionListener(this);
	arite.setActionCommand("ARITE");
	arite.setText("1");

	//isrr = new JCheckBox("Regular relation"); 
	//isrr.setBounds(270,10,150,20);
	//isrr.addActionListener(this);
	//isrr.setActionCommand("ISRR"); 

	JLabel lsymbol = new JLabel("Enter a symbol :"); 
	lsymbol.setBounds(20,30,200,20); 
	symbol = new JTextField(); 
	symbol.setBounds(230,30,300,20);
	symbol.addActionListener(this);
	symbol.setActionCommand("SYMBOL");

	JLabel lsymbol_saisie = new JLabel("List of symbols :"); 
	lsymbol_saisie.setBounds(20,90,200,30); 
	symbol_saisie = new JList();
	symbol_saisie.setSelectionMode(DefaultListSelectionModel.MULTIPLE_INTERVAL_SELECTION);	
	symbol_saisie.setModel(new DefaultListModel());    
	JScrollPane jsp_symbol_saisie = new JScrollPane(); 
	jsp_symbol_saisie.setBounds(20,120,240,190); 
	jsp_symbol_saisie.getViewport().add(symbol_saisie); 
	undoS = new JButton("Delete",new ImageIcon("images/delete.gif"));  
	undoS.setBounds(80,320,120,40);
	undoS.addActionListener(this);
	undoS.setActionCommand("DELSYMB");
	
	//ETATS 310,20,260,450
	JLabel letat = new JLabel("Enter a state :"); 
	letat.setBounds(20,50,180,20); 
	etat = new JTextField(); 
	etat.setBounds(230,50,200,20);
	etat.addActionListener(this);
	etat.setActionCommand("ETAT"); 
	isfinal = new JCheckBox("Final state"); 
	isfinal.setBounds(440,50,100,20);
	isfinal.addActionListener(this);
	isfinal.setActionCommand("ISFINAL"); 	
	JLabel letat_saisie = new JLabel("List of states :"); 
	letat_saisie.setBounds(310,90,170,20); 
	etat_saisie = new JList();
	etat_saisie.setSelectionMode(DefaultListSelectionModel.MULTIPLE_INTERVAL_SELECTION);	
	etat_saisie.setModel(new DefaultListModel());
	JScrollPane jsp_etat_saisie = new JScrollPane(); 
	jsp_etat_saisie.setBounds(310,120,240,180); 
	jsp_etat_saisie.getViewport().add(etat_saisie); 	 	
	undoE = new JButton("Delete",new ImageIcon("images/delete.gif")); 
	undoE.setBounds(370,320,120,30);
	undoE.addActionListener(this);
	undoE.setActionCommand("DELETAT");


	add(jsp_symbol_saisie); 
	add(jsp_etat_saisie); 
	add(lsymbol); 
	add(letat); 
	add(symbol); 
	add(etat); 
	add(lsymbol_saisie); 
	add(letat_saisie); 
	add(isfinal); 
	add(undoS); 
	add(undoE);

	add(ariteRR);
	add(arite);
	//add(isrr);
    }
    /** 
     *Vide les listes et les champs de saisies 
    */ 
    public void vide_liste() { 
	    symbol.setText(""); 
	    etat.setText(""); 
	    utils.emptyList(symbol_saisie); 
	    utils.emptyList(etat_saisie); 	  
    } 
    public void actionPerformed(ActionEvent e){

	//Suppression de symboles.
	if(e.getActionCommand().equals("DELSYMB")){
	    gui.utils.delItems(symbol_saisie,parent.data.getA_saisie());
	    parent.sr.choixS.removeActionListener(parent);
	    //Suppression de tous les items de la combo box.
	    parent.sr.choixS.removeAllItems();
	    //Remplissage de la combo box.	    
	    for(int i=0;i<((DefaultListModel)symbol_saisie.getModel()).getSize();i++){
		
		//parent.sr.choixS.addItem(((DefaultListModel)symbol_saisie.getModel()).getElementAt(i)); mieux???
		parent.sr.choixS.addItem(parent.data.getA_saisie().getSymbole(i).convertSymbolFonction());
	    }
	    parent.sr.choixS.addActionListener(parent); 
	    parent.fe.choixS.removeActionListener(parent);
	    //Suppression de tous les items de la combo box.
	    parent.fe.choixS.removeAllItems(); 
	    //Remplissage de la combo box.
	    for(int i=0;i<((DefaultListModel)symbol_saisie.getModel()).getSize();i++){
		//parent.fe.choixS.addItem(((DefaultListModel)symbol_saisie.getModel()).getElementAt(i));mieux ???
		parent.fe.choixS.addItem(parent.data.getA_saisie().getSymbole(i).convertSymbolFonction());
	    }
	    //Mise  jour de la liste de transitions si case coche.
	    if(true){
		gui.utils.emptyList(parent.sr.regle_saisie);
		for(int i=0;i<parent.data.getT_saisie().size();i++){
		    boolean found = false;
		    //Recherche du symbole de la rgles dans l'alphabet.
		    for(int j=0;j<parent.data.getA_saisie().size();j++){
			if(parent.data.getCondition(i).contains(parent.data.getSymbole(j))){
			    found=true;
			    break;
			}
		    }
		    if(!found){
			//suppression de la rgle dans le vecteur
			parent.data.getT_saisie().removeElementAt(i);
			i--;
		    }else{
			//Ajout de la rgle dans la JList		       
			((DefaultListModel)parent.sr.regle_saisie.getModel()).addElement(parent.data.getTransition(i).print());
		    }
		}
	    }
	    parent.fe.choixS.addActionListener(parent); 
	    parent.data.setAutomate_ok(false); 
	    parent.activation_onglet();	    	    
	}else{
	    //Suppression d'tats.
	    if(e.getActionCommand().equals("DELETAT")){		
		gui.utils.delItems(etat_saisie,parent.data.getE_saisie());
		parent.sr.choixE.removeActionListener(parent);
		//Suppression de tous les items de la combo box.
		parent.sr.choixE.removeAllItems();
		//Remplissage de la combo box.
		for(int i=0;i<((DefaultListModel)etat_saisie.getModel()).getSize();i++){
		    parent.sr.choixE.addItem(parent.data.getLibelle(i));
		}
		//Mise  jour de la liste de transitions si case coche.
		if(true){
		    gui.utils.emptyList(parent.sr.regle_saisie);
		    for(int i=0;i<parent.data.getT_saisie().size();i++){
			boolean ok = true;
			//Recherche : la rgle ne doit contenir que des tats connu.
			//1- tat obtenu.
			if(parent.data.getE_saisie().getEtatIndex(parent.data.getEtatObtenu(i).getLibelle())!=-1){
			    //2-les paramtres de la conditions.
			    for(int j=0;j<parent.data.getCondition(i).getArbre().getSousArbres().size();j++){
				if(parent.data.getE_saisie().getEtatIndex(parent.data.getCondition(i).getArbre().getSousArbre(j).getValeur())==-1){
				    ok=false;
				    break;
				}
			    }
			}else{
			    ok = false;
			}
			if(!ok){
			    //suppression de la rgle dans le vecteur
			    parent.data.getT_saisie().removeElementAt(i);
			    i--;
			}else{
			    //Ajout de la rgle dans la JList		       
			    ((DefaultListModel)parent.sr.regle_saisie.getModel()).addElement(parent.data.getTransition(i).print());
			}
		    }
		}
		parent.sr.choixE.addActionListener(parent); 
		parent.data.setAutomate_ok(false); 
		parent.activation_onglet();				
	    }else{
		//Ajout d'tat.
		if(e.getActionCommand().equals("ETAT") || e.getActionCommand().equals("ISFINAL")) 
		    { 
			if(!etat.getText().equals("")) 
			    { 
				etat etat1= new etat(etat.getText(),false);
				etat etat2= new etat(etat.getText(),true);
				symbole s = new symbole(etat.getText()+"/0"); 
				String fonction = s.convertSymbolFonction();
			
				if ( parent.data.getA_saisie().app(s.getSymbole())!=-1)
				    { 
					JOptionPane.showMessageDialog(this,"This name already exists in the symbol list","Error Message",JOptionPane.ERROR_MESSAGE);
				    }
				else
				    {
					if (parent.data.getE_saisie().contains(etat1) || parent.data.getE_saisie().contains(etat2))
					    {
					
						JOptionPane.showMessageDialog(this,"This state already exists","Error Message",JOptionPane.ERROR_MESSAGE); 
					    }
					else
					    {
						
						if(!isfinal.isSelected())			   			   
						    ((DefaultListModel)etat_saisie.getModel()).addElement(etat.getText());
						else 
						    ((DefaultListModel)etat_saisie.getModel()).addElement(etat.getText()+" (final)"); 
						parent.data.addEtat(etat.getText(),isfinal.isSelected()); 
					    }
				    }
				parent.sr.choixE.removeActionListener(this); 
				parent.sr.choixE.addItem(etat.getText()); 
				parent.sr.choixE.addActionListener(this); 
				etat.setText(""); 
				isfinal.setSelected(false); 
				parent.data.setAutomate_ok(false); 
				parent.activation_onglet(); 
			    } 
		    }
		else
		    {
			//Ajout de symbole.
			if(e.getActionCommand().equals("SYMBOL")) { 
			if(!symbol.getText().equals("")) { 
			    try 
				{ 
				    symbole s = new symbole(symbol.getText()); 
				  
				    String fonction = s.convertSymbolFonction(); 	
				    etat etat1= new etat(s.getSymbole(),false);
				    etat etat2= new etat(s.getSymbole(),true);
				   
				    if (parent.data.getE_saisie().contains(etat1) || parent.data.getE_saisie().contains(etat2))
					{
					    JOptionPane.showMessageDialog(this,"This name already exists in the state list","Error Message",JOptionPane.ERROR_MESSAGE); 
					}
				    else

				    if ( parent.data.getA_saisie().app(s.getSymbole())==-1)
					{ 
					   
					    parent.data.addSymbole(s); 
					    int arity = parent.data.isRR;
					    automate a1 =new automate(parent.data.getA_saisie(),parent.data.getE_saisie(),parent.data.getT_saisie(),parent.data.getA_saisie().alphabetRR(parent.data.getA_saisie(),arity));
					    a1.isRR = arity;
					    utils.listes(a1,parent);
					    
					    
					}
				    else 
					{
					    JOptionPane.showMessageDialog(this,"This symbol already exists","Error Message",JOptionPane.ERROR_MESSAGE); 
					}
				    //  parent.sr.choixS.removeActionListener(this); 
				    //parent.sr.choixS.addItem(fonction); 
				    //parent.sr.choixS.addActionListener(this); 
				    //parent.fe.choixS.removeActionListener(this); 
				    //parent.fe.choixS.addItem(fonction); 
				    //parent.fe.choixS.addActionListener(this); 
				} 
			    catch(StringIndexOutOfBoundsException err) { 
				JOptionPane.showMessageDialog(this,"Type something like  'string/integer'","Error Message",JOptionPane.ERROR_MESSAGE); 
			    } 
			    catch(NumberFormatException err) { 
				JOptionPane.showMessageDialog(this,"The arity of a symbol should be an integer","Error Message",JOptionPane.ERROR_MESSAGE); 
			    } 
			    symbol.setText(""); 
			    parent.data.setAutomate_ok(false); 
			    parent.activation_onglet(); 
			}
		    }//if
		}//else
	    }//else
	}//else 

	try 
	    {
		int anc_arit = parent.data.isRR;
	
		if (e.getActionCommand().equals("ARITE") ) { 
		    parent.data.isRR = (new Integer(arite.getText())).intValue(); 

		    if (parent.data.isRR !=1 )
			{
			  
			    if (  parent.data.getA_saisie().app("#")==-1) 
				{((DefaultListModel)symbol_saisie.getModel()) .addElement("#/0"); 
				    parent.data.addSymbole(new symbole("#/0"));
				    parent.sr.choixS.removeActionListener(this); 
				    parent.sr.choixS.addItem("#"); 
				    parent.sr.choixS.addActionListener(this); 
				    parent.fe.choixS.removeActionListener(this); 
				    parent.fe.choixS.addItem("#"); 
				    parent.fe.choixS.addActionListener(this); 
				}
			}
		    
		    else
			{
			    arite.setText("1"); parent.data.isRR=1;
			    if (parent.data.getA_saisie().app("#")!=-1)
				{
				    parent.data.getA_saisie().removeElementAt(parent.data.getA_saisie().getSymboleIndex("#"));	
				    ((DefaultListModel)symbol_saisie.getModel()) .removeElement("#/0"); 
				    parent.sr.choixS.removeActionListener(this); 
				    parent.sr.choixS.removeItem("#"); 
				    parent.sr.choixS.addActionListener(this); 
				    parent.fe.choixS.removeActionListener(this); 
				    parent.fe.choixS.removeItem("#"); 
				    parent.fe.choixS.addActionListener(this); 
				}
			}
		} 
			
	
	    }
	catch(NumberFormatException err) 
	    { 
	    JOptionPane.showMessageDialog(this,"The arity of regular relation should be an integer !","Error message",JOptionPane.ERROR_MESSAGE); 
 
	}
   
    }//actonPerformed

}//class
 
