/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui;

import java.io.*;
import javax.swing.*;
import javax.swing.tree.*;
import data.*;
import java.util.*;

public class utils{  
    public static arbre recupere(Vector v, int i,int n)
    {
	if ( ((arbre)v.elementAt(i)).getSousArbres().size() > n )
	    return ((arbre)v.elementAt(i)).getSousArbre(n);
	else
	    return new arbre("#");
    }
    public static String decoupe(Vector v,automate data)
    {
	String racine = "";
	Vector v2 = new Vector();
	for (int j=0;j<v.size();j++)
	    {

		arbre a = (arbre)v.elementAt(j);
	
		if (j==v.size()-1)
		    racine += a.getValeur();
		else 
		    racine += a.getValeur()+"|";
		v2.addElement(a);
		
	
	
	    }
	int arity = data.getA_saisie().app(racine);

	if (arity != -1 )
	    {
		if (arity == 0)  // constante
		    {
		
		    }
		else //fonction
		    {
			racine +="(";
			for ( int i=1;i<arity+1;i++)
			    {
				
				Vector v3 = new Vector();
				for ( int j=0;j<v.size();j++)
				    {
					v3.addElement(recupere(v,j,i-1));
				
				    }
				if (i==arity)
				    racine += decoupe(v3,data);
				else 
				    racine += decoupe(v3,data)+",";
			    }
			racine += ")";
		    }
	
	    }
    

	return racine;
    }
    public static String recuperer(String chaine,String indice)
    {
	int n = chaine.indexOf(indice+",");
	if ( n == -1 )
	    return "#";
	else
	    {
		String ch = chaine.substring(n+indice.length()+1,chaine.length());
	
		int n2 = ch.indexOf("|");
		if (  n2 == -1 )
		    return ch;
		else return ch.substring(0,n2);
	    }
    }
    public static String decouple(arbre a,String ch)
    {
	String resultat = "("+ch+")"+","+a.getValeur();
	for (int j=0;j<a.getSousArbres().size();j++)
	    {
		int n = j+1;
		resultat += "|"+decouple(a.getSousArbres().getArbre(j),ch+n);
	    }
	return resultat;
    }
    public static automate renomme(automate a1, automate a2)


    {
	
	boolean modif = false;
	String[] old_lib = new String[a2.getE_saisie().size()];
	String[] new_lib = new String[a2.getE_saisie().size()];
	//Parcourt de la liste d'tat. recherche de { ou de } et modif si necessaire.
	for(int i=0;i<a2.getE_saisie().size();i++)
	    {
		old_lib[i] = new String(a2.getLibelle(i));
		new_lib[i] = new String(a2.getLibelle(i));
		while (a1.getE_saisie().contains2(new_lib[i]))
		    {
			new_lib[i] = "R_"+new_lib[i];
		    }
		       
	    }
	String retour = new String("");
	for (int i=0;i<a2.getE_saisie().size();i++){
	    a2.getE_saisie().getEtat(i).rename(old_lib, new_lib);
		
		
	   
	}
	//Parcourt de la liste de rgles et modifs.
	for(int j=0;j<a2.getT_saisie().size();j++){
	    //Modif de l'tat obtenu.
	    for(int i=0;i<old_lib.length;i++){
		if(a2.getEtatObtenu(j).rename(old_lib, new_lib)){
		    break;
		}
	    }
	    //Modif de la condition.
	    for(int i=0;i<old_lib.length;i++){
		a2.getCondition(j).getArbre().rename(old_lib, new_lib);
		a2.getCondition(j).setFonction();
	    }
	    
	}

	return a2;
	
    }

    public static automate renomme_tous(automate a2,fenetre_saisie parent)
    {
	
	utils.save(a2,parent.user_dir+"/tempo2.ta");
	automate a = new automate(new File(parent.user_dir+"/tempo2.ta"));
	boolean del = (new File(parent.user_dir+"/tempo2.ta")).delete();
	boolean modif = false;
	String[] old_lib = new String[a.getE_saisie().size()];
	String[] new_lib = new String[a.getE_saisie().size()];
	//Parcourt de la liste d'tat. recherche de { ou de } et modif si necessaire.	
	
	for(int i=0;i<a.getE_saisie().size();i++)
	    {
		old_lib[i] = new String(a.getLibelle(i));
		new_lib[i] = new String(a.getLibelle(i));
		new_lib[i] = "Q"+i;
		       
	    }

	String retour = new String("");
	for (int i=0;i<a.getE_saisie().size();i++){
	    a.getE_saisie().getEtat(i).rename(old_lib, new_lib);

		
	   
	}
	//Parcourt de la liste de rgles et modifs
	for(int j=0;j<a.getT_saisie().size();j++){ 
	    //Modif de l'tat obtenu.
	    for(int i=0;i<old_lib.length;i++){
		if(a.getEtatObtenu(j).rename(old_lib, new_lib)){
		    break;
		}
	    }
	    //Modif de la condition.
	    for(int i=0;i<old_lib.length;i++){
		a.getCondition(j).getArbre().rename(old_lib, new_lib);
		a.getCondition(j).setFonction();
	    }
	    
	}
	return a;
	
    }

    public static Vector renvoie_join(String st, int arity, int choix)
    {

	renvoie_proj(st.substring(0,st.indexOf(".")),arity).elementAt(1);
	if ( choix == 1 )
	    return (Vector)renvoie_proj(st.substring(0,st.indexOf(".")),arity).elementAt(1);
	else
	    return (Vector)renvoie_proj(st.substring(st.indexOf(".")+1,st.length()),arity).elementAt(1);
    }

    public static Vector renvoie_proj(String st, int arity )
    {

	String num;
	int nb;
	boolean ok=true;
	Vector vec =new Vector();
	while ( st.indexOf("/") != -1 )
	    {
		//StringIndexOutOfBoundsException
		num = st.substring(0,st.indexOf("/"));
		st = st.substring(st.indexOf("/")+1,st.length());
		nb= (new Integer(num)).intValue();
	
		if (nb > arity) { ok =false;}
		vec.addElement(new Integer(num));
	    }
	
		
	nb= (new Integer(st)).intValue();
	if (nb > arity) { ok =false;}
	vec.addElement(new Integer(st));

	Vector retour = new Vector();
	if (ok) retour.addElement(new Integer(1)); else retour.addElement(new Integer(0));
	retour.addElement(vec);
	
	return retour;
    }

    
    

    public static String renvoie_fonct(String st, int n,int arity )
    {

	if (n==1) return st.substring(0,st.indexOf("|"));
	else 
	    {
		int i=2;
		int index = st.indexOf("|");
	
		String reste = st.substring(st.indexOf("|")+1,st.length());
		while (i<n && index!=-1)
		    {
			reste = reste.substring(index+1,reste.length());
			i++;
			index = reste.indexOf("|");
			
		    }
		index = reste.indexOf("|");
	
		if (i==n && index!=-1) return reste.substring(0,reste.indexOf("|"));
		else if ( i==n ) return reste.substring(0,reste.length());
	    }
	return "";
    }

    public static void enregistrer(automate data, fenetre_saisie parent){
	JFileChooser dir = new JFileChooser();
	javax.swing.filechooser.FileFilter[] ff = dir.getChoosableFileFilters();//getChoosableFileFilters()
	for(int i=0;i<ff.length;i++){
	    dir.removeChoosableFileFilter(ff[i]);
	}
	javax.swing.filechooser.FileFilter theFF = new automateFileFilter();	
	dir.setFileFilter(theFF);	
	dir.setDialogTitle("Save in a file"); 
	//dir.setCurrentDirectory(new File(".")); 
	int result = dir.showSaveDialog(parent); 
	if(result == JFileChooser.APPROVE_OPTION) { 
	    try {
		String filename = dir.getSelectedFile().getAbsolutePath();
		if(!filename.endsWith(".ta")){
		    filename = filename+".ta";
		}
		PrintWriter out = new PrintWriter(new FileWriter(filename),true); 
	
		
		out.println("Length of tree-tuples:");
		out.println(data.isRR);
		out.println();
		out.println("Symbols:"); 
		for(int i=0;i<data.getA_saisie().size();i++) { 
		    out.println(data.getSymbole(i)+"/"+data.getArite(i)); 
		} 
		out.println("");
		out.println("States:"); 
		for(int i=0;i<data.getE_saisie().size();i++) { 
		    if(data.isFinal(i)) out.println(data.getLibelle(i)+" (final)"); 
		    else out.println(data.getLibelle(i)); 
		} 
		out.println("");
		out.println("Transitions:"); 
		for(int i=0;i<data.getT_saisie().size();i++) { 
		    out.println(data.getCondition(i).getFonction()+"->"+data.getEtatObtenu(i).getLibelle()); 
		} 
		out.println("");
		out.println("SymbolRRs:");
		for(int i=0;i<data.getARR_saisie().size();i++) { 
		    out.println(data.getARR_saisie().getSymbole(i).getLibelle()); 
		} 
		out.println("."); 
		if(out.checkError()) JOptionPane.showMessageDialog(parent,"Error while saving","Error message",JOptionPane.ERROR_MESSAGE); 
		else{ 
		    JOptionPane.showMessageDialog(parent," File saved ","Information message",JOptionPane.INFORMATION_MESSAGE);
		    parent.op.tree.addToSession(filename);
		}
	    } 
	    catch(IOException e) { 
		JOptionPane.showMessageDialog(parent,"Error while saving: "+e.getMessage(),"Error message",JOptionPane.ERROR_MESSAGE); 
	    } 
	}
    }

 
    public static void save(automate data, String filename){
	try {
	    PrintWriter out = new PrintWriter(new FileWriter(filename),true); 
	    out.println("Length of tree-tuples:");
	    out.println(data.isRR);
	    out.println();
	    out.println("Symbols:"); 
	    for(int i=0;i<data.getA_saisie().size();i++) { 
		out.println(data.getSymbole(i)+"/"+data.getArite(i)); 
	    }  
	    out.println("");
	    out.println("States:"); 
	    for(int i=0;i<data.getE_saisie().size();i++) { 
		if(data.isFinal(i)) out.println(data.getLibelle(i)+" (final)"); 
		else out.println(data.getLibelle(i)); 
	    }  
	    out.println("");
	    out.println("Transitions:"); 
	    for(int i=0;i<data.getT_saisie().size();i++) { 
		out.println(data.getCondition(i).getFonction()+"->"+data.getEtatObtenu(i).getLibelle()); 
	    } 
	    if ( data.isRR !=1 )
		{ 
		    out.println("");
		    out.println("SymbolRRs:");
		    for(int i=0;i<data.getARR_saisie().size();i++) { 
			out.println(data.getARR_saisie().getSymbole(i).getLibelle()); 
		    } 
		}
	    out.println(".");
	    out.close();
	} 
	catch(IOException e) { }
    }
  
    public static boolean listes(automate data,fenetre_saisie parent)
    {

	 parent.sse.vide_liste(); 
	 parent.sr.vide_liste(parent); 
	 parent.fe.vide_liste(parent); 
	 if(data.getException() == null) { 
	     Integer ess = new Integer(0);
	     String essai = ess.toString(data.isRR);
	     parent.sse.arite.setText(essai);
	     alphabet alp =new alphabet(); 
	     
	     if ( data.isRR ==1 ) alp = data.getA_saisie(); else alp =data.getARR_saisie();
	     
	     for(int i = 0; i < alp.size(); i++) { 
		 if (data.isRR ==1 )((DefaultListModel)parent.sse.symbol_saisie.getModel()).addElement(new String(alp.getSymbole(i).getSymbole() + "/" + alp.getSymbole(i).getArite()));
		 String fonction = alp.getSymbole(i).convertSymbolFonction(); 
		 parent.sr.choixS.removeActionListener(parent); 
		 parent.sr.choixS.addItem(fonction); 
		parent.sr.choixS.addActionListener(parent); 
		if ( i ==0) parent.selS = alp.getSymbole(0).convertSymbolFonction(); 
	     } 
	    for(int i = 0; i < data.getA_saisie().size(); i++) { 
	
		if (data.isRR !=1 )((DefaultListModel)parent.sse.symbol_saisie.getModel()).addElement(new String(data.getSymbole(i) + "/" + data.getArite(i)));
		String fonction = data.getA_saisie().getSymbole(i).convertSymbolFonction(); 
		if ( i ==0) parent.selS2 = data.getA_saisie().getSymbole(0).convertSymbolFonction(); 
		parent.fe.choixS.removeActionListener(parent); 
		parent.fe.choixS.addItem(fonction); 
		parent.fe.choixS.addActionListener(parent); 
	    } 
	    for(int j = 0; j < data.getE_saisie().size(); j++) { 
	    
		if(data.isFinal(j))		      
		    ((DefaultListModel)parent.sse.etat_saisie.getModel()).addElement(new String(data.getLibelle(j) + " (final)"));
		else  
		    ((DefaultListModel)parent.sse.etat_saisie.getModel()).addElement(data.getLibelle(j));
		    
		parent.sr.choixE.removeActionListener(parent); 
		parent.sr.choixE.addItem(data.getLibelle(j)); 
		parent.sr.choixE.addActionListener(parent); 
	    } 
	    for(int k = 0; k < data.getT_saisie().size(); k++){ 		    
		((DefaultListModel)parent.sr.regle_saisie.getModel()).addElement(data.getCondition(k).getFonction() + "->" + data.getEtatObtenu(k).getLibelle()); 
	    }
	    
	    if (data.getE_saisie().size()!=0 )
		{
		parent.selE =data.getLibelle(0);
		}
	    parent.sr.choixE.setVisible(false);
	}
	return true;
    }
    
    public static automate ouvrir(fenetre_saisie parent){
	automate data = new automate();
	JFileChooser dir = new JFileChooser();
	javax.swing.filechooser.FileFilter[] ff = dir.getChoosableFileFilters();//getChoosableFileFilters()
	for(int i=0;i<ff.length;i++){
	    dir.removeChoosableFileFilter(ff[i]);
	}
	
	javax.swing.filechooser.FileFilter theFF = new automateFileFilter();	
	dir.setFileFilter(theFF);
	dir.setDialogTitle("Open a file"); 
	//dir.setCurrentDirectory(new File(".")); 
	int result = dir.showOpenDialog(parent); 
	
	if(result == JFileChooser.APPROVE_OPTION) { 
	    data = new automate(dir.getSelectedFile()); 
	    
	    if (data.isRR !=1)
		{
		    int arity =data.isRR;
		    data =new automate(data.getARR_saisie(),data.getE_saisie(),data.getT_saisie(),data.getA_saisie());
		    data.isRR = arity;
		    listes(data,parent);
		}
	    else listes(data,parent);
	    //	    symbole sim;
	    //	    alphabet alp=new alphabet();
	    //	    alp.addSymbole(new symbole("#/0"));
	    //	    for (int i=0;i<data.getA_saisie().size();i++)
	    //		{
	    //		    String st = data.getA_saisie().getSymbole(i).getSymbole();
	    //		    for (int j=1;j<data.isRR;j++)
	    //			{
	    //			   
	    //			    sim = new symbole(st.substring(0,st.indexOf("|"))+"/1");
	    //			    if (alp.app(st.substring(0,st.indexOf("|"))) == -1)
	    //				{
	    //				    alp.addSymbole(sim);
	    //				}
	    //			    st = st.substring(st.indexOf("|")+1,st.length());
	    //			    
	    //			}
	    //		}
	    //	    int a = data.isRR;
	    //	    data = new automate(alp,data.getE_saisie(),data.getT_saisie(),new alphabet());
	    //	    data.isRR = a;
	    //	}
	     
	     
	} 
	else { 
	    JOptionPane.showMessageDialog(parent, data.getException(), "Error message", 0); 
	    data = new automate(); 
	}
	
	return data;
    }

  
    public static String choisirFichier(JFrame parent){
	String retour = new String("");
	JFileChooser dir = new JFileChooser(); 
	javax.swing.filechooser.FileFilter[] ff = dir.getChoosableFileFilters();//getChoosableFileFilters()
	for(int i=0;i<ff.length;i++){
	    dir.removeChoosableFileFilter(ff[i]);
	}
	javax.swing.filechooser.FileFilter theFF = new automateFileFilter();	
	dir.setFileFilter(theFF);
	dir.setDialogTitle("Select a file"); 
	int result = dir.showOpenDialog(parent);
	if(result == JFileChooser.APPROVE_OPTION)
	    retour = dir.getSelectedFile().getAbsolutePath();
	return retour;
    }

    public static String choisirDir(JFrame parent){
	String retour = new String("");
	JFileChooser dir = new JFileChooser();
	dir.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
	dir.setDialogTitle("Select a directory");
	int result = dir.showOpenDialog(parent);
	if(result == JFileChooser.APPROVE_OPTION)
	    retour = dir.getSelectedFile().getAbsolutePath();
	return retour;
    }

    public static void enregistrerTreeNode(JFrame parent, TreeModel data){
	try{
	    JFileChooser dir = new JFileChooser();
	    javax.swing.filechooser.FileFilter[] ff = dir.getChoosableFileFilters();//getChoosableFileFilters()
	    for(int i=0;i<ff.length;i++){
		dir.removeChoosableFileFilter(ff[i]);
	    }
	    javax.swing.filechooser.FileFilter theFF = new treeModelFileFilter();	
	    dir.setFileFilter(theFF); 
	    dir.setDialogTitle("Save of automaton list");
	    int result = dir.showSaveDialog(parent);	    
	    if(result == JFileChooser.APPROVE_OPTION){
		String nomfichier = dir.getSelectedFile().getAbsolutePath();
		if(!nomfichier.endsWith(".tal"))
		    nomfichier = nomfichier+".tal";
		FileOutputStream fo = new FileOutputStream(nomfichier);
		ObjectOutputStream so = new ObjectOutputStream(fo);
		so.writeObject(data);
		so.flush();
		so.close();
	    }
	}catch(IOException e){}
    }

    public static TreeModel ouvrirTreeNode(fenetre_saisie parent, JTree tree){
	TreeModel retour = tree.getModel();
	String nomfichier = new String("");
	JFileChooser dir = new JFileChooser(); 
	javax.swing.filechooser.FileFilter[] ff = dir.getChoosableFileFilters();//getChoosableFileFilters()
	for(int i=0;i<ff.length;i++){
	    dir.removeChoosableFileFilter(ff[i]);
	}
	javax.swing.filechooser.FileFilter theFF = new treeModelFileFilter();	
	dir.setFileFilter(theFF);
	dir.setDialogTitle("Select an automaton list"); 
	int result = dir.showOpenDialog(parent);
	if(result == JFileChooser.APPROVE_OPTION){
	    nomfichier = dir.getSelectedFile().getAbsolutePath();
	    try{
		FileInputStream fi = new FileInputStream(nomfichier);
		ObjectInputStream si = new ObjectInputStream(fi);
		retour = (TreeModel) si.readObject();
		si.close();
	    }catch(ClassNotFoundException e){System.out.println(e.getMessage());}
	    catch(IOException e){System.out.println(e.getMessage());}
	}
	return retour;
    }

    /* Manipulation de JList */
    public static void delItems(JList liste, Vector vecteur){
	for(int i=0;i<((DefaultListModel)liste.getModel()).getSize();i++){
	    if(liste.isSelectedIndex(i)){
		((DefaultListModel)liste.getModel()).removeElementAt(i);
		vecteur.removeElementAt(i);
		i--;
	    }
	}
    }

    public static void emptyList(JList liste)
    {



	while (liste.getModel().getSize()!=0)
	    {	
		((DefaultListModel)liste.getModel()).removeElementAt(0);
	    }    
    }


    public static automate charger_auto(automate a,fenetre_saisie parent){
	automate retour = a.copy();
	if(retour.getException() == null) { 
	    listes(retour,parent);
	 //    for(int i = 0; i < retour.getA_saisie().size(); i++) { 
// 		((DefaultListModel)parent.sse.symbol_saisie.getModel()).addElement(new String(retour.getSymbole(i) + "/" + retour.getArite(i)));
// 		String fonction = retour.getA_saisie().getSymbole(i).convertSymbolFonction(); 
// 		parent.sr.choixS.removeActionListener(parent); 
// 		parent.sr.choixS.addItem(fonction); 
// 		parent.sr.choixS.addActionListener(parent); 
// 		parent.fe.choixS.removeActionListener(parent); 
// 		parent.fe.choixS.addItem(fonction); 
// 		parent.fe.choixS.addActionListener(parent); 
// 	    } 
// 	    for(int j = 0; j < retour.getE_saisie().size(); j++) { 
// 		if(retour.isFinal(j)) ((DefaultListModel)parent.sse.etat_saisie.getModel()).addElement(new String(retour.getLibelle(j) + " (final)"));
// 		else ((DefaultListModel)parent.sse.etat_saisie.getModel()).addElement(retour.getLibelle(j));
// 		parent.sr.choixE.removeActionListener(parent); 
// 		parent.sr.choixE.addItem(retour.getLibelle(j)); 
// 		parent.sr.choixE.addActionListener(parent); 
// 	    } 
// 	    for(int k = 0; k < retour.getT_saisie().size(); k++){ 	       
// 		((DefaultListModel)parent.sr.regle_saisie.getModel()).addElement(retour.getCondition(k).getFonction() + "->" + retour.getEtatObtenu(k).getLibelle()); 
// 	    }
	} 
	else { 
	    JOptionPane.showMessageDialog(parent, retour.getException(), "Error message", 0); 
	    retour = new automate(); 
	}
	return retour;
    }

   
}
