/* <T.T.S.L.I Tree-tuple Synchronized languages Implementation >
*Copyright (C) <2002>  <LECLAND Benoit>

*This program is free software; you can redistribute it and/or modify
*it under the terms of the GNU General Public License as published by
*the Free Software Foundation; either version 2 of the License, or
*(at your option) any later version.

*This program is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*GNU General Public License for more details.

*You should have received a copy of the GNU General Public License
*along with this program; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package gui;

import com.sun.image.codec.jpeg.*;
//import java.awt.Graphics.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;
import javax.swing.*;

public class utilsGraph{
   
public static void writeJpegFile(JComponent component,String fileName, int border) { 
    //File file = new File(filePath);
  
    Point location = component.getLocation();
    Dimension size = component.getSize();
    
    // Create a buffered image and let the component draw into it
  
    BufferedImage tempImage = new BufferedImage(size.width, size.height, BufferedImage.TYPE_INT_RGB);
    Graphics tempGraphics = tempImage.getGraphics();
    component.paint(tempGraphics);
  
    // Create another buffered image that holds the component and the border 
  
    BufferedImage bufferedImage = new BufferedImage(size.width + 2 * border, size.height + 2 * border,BufferedImage.TYPE_INT_RGB);
    Graphics bufferedGraphics = bufferedImage.getGraphics();
    bufferedGraphics.setColor(Color.white); // Put your background color here  
    bufferedGraphics.fillRect(0, 0, size.width + 2 * border, size.height + 2 * border);  
    bufferedGraphics.drawImage(tempImage, border, border, size.width, size.height, null); 
    
    // Write image to file
    
    try {
	//fileName = filePath + fileName;
	FileOutputStream out = new FileOutputStream(fileName);
	BufferedOutputStream bufferedOutput = new BufferedOutputStream(out);   
	JPEGImageEncoder encoder = JPEGCodec.createJPEGEncoder(bufferedOutput);   
        JPEGEncodeParam param = encoder.getDefaultJPEGEncodeParam(bufferedImage);
	param.setQuality(1.0f, false);
        encoder.setJPEGEncodeParam(param);
	encoder.encode(bufferedImage);
	bufferedOutput.close();
    }
    catch (FileNotFoundException e) {
	System.out.println("writeJpegFile: Got a FileNotFoundException"); }
    catch (IOException e) {
	System.out.println("writeJpegFile: Got an IOException");   }
} // writeJpegFile


public static void enregistrerExpression(JFrame parent, JComponent expression){
	    JFileChooser dir = new JFileChooser();
	   javax.swing.filechooser.FileFilter[] ff = dir.getChoosableFileFilters();//getChoosableFileFilters()
	   for(int i=0;i<ff.length;i++){
	       dir.removeChoosableFileFilter(ff[i]);
	   }
	   javax.swing.filechooser.FileFilter theFF = new jpegFileFilter();	
	   dir.setFileFilter(theFF); 
	   dir.setDialogTitle("Save expression");
	   int result = dir.showSaveDialog(parent);	    
	   if(result == JFileChooser.APPROVE_OPTION){
	       String nomfichier = dir.getSelectedFile().getAbsolutePath();
	       if(!nomfichier.endsWith(".jpg"))
		   nomfichier = nomfichier+".jpg";
	       writeJpegFile(expression,nomfichier,2);
	      
	   }
    }



    public static String enregistrerRun(JFrame parent){
	String retour = new String();
	JFileChooser dir = new JFileChooser();
	javax.swing.filechooser.FileFilter[] ff = dir.getChoosableFileFilters();//getChoosableFileFilters()
	for(int i=0;i<ff.length;i++){
	    dir.removeChoosableFileFilter(ff[i]);
	}
	javax.swing.filechooser.FileFilter theFF = new jpegFileFilter();	
	dir.setFileFilter(theFF); 
	dir.setDialogTitle("Save expression");
	int result = dir.showSaveDialog(parent);	    
	if(result == JFileChooser.APPROVE_OPTION){
	    String nomfichier = dir.getSelectedFile().getAbsolutePath();
	    if(!nomfichier.endsWith(".jpg"))
		nomfichier = nomfichier+".jpg";
	    //	    writeJpegFile(expression,nomfichier,2);
	    retour = nomfichier;
	}
	return retour;
    }    
}
